      PROGRAM ARODEM

      IMPLICIT NONE

C--       global variables
      INTEGER LSTHFL
      REAL*8 PARHFL,CUTHFL
      COMMON /HFDATA/ PARHFL(10),CUTHFL(8),LSTHFL(10)
      INTEGER LST
      REAL CUT,PARL,X,Y,W2,Q2,U
      COMMON /LEPTOU/ CUT(14),LST(40),PARL(30),X,Y,W2,Q2,U
      INTEGER N,K
      REAL P,V
      COMMON /LUJETS/N,K(4000,5),P(4000,5),V(4000,5)
      INTEGER MSTU,MSTJ
      REAL PARU,PARJ
      COMMON /LUDAT1/MSTU(200),PARU(200),MSTJ(200),PARJ(200)
      INTEGER KCHG
      REAL PMAS,PARF,VCKM
      COMMON /LUDAT2/KCHG(500,3),PMAS(500,4),PARF(2000),VCKM(4,4)
      INTEGER IFLQ,IFLQB
      REAL SHAT,ETA,Z,PHIQQ,PT2Q,TM2Q1,TM2Q2,ZJ,PHIFL
      REAL*8 DBETAZ
      COMMON /HFLVAR/ SHAT,ETA,Z,PHIQQ,PT2Q,TM2Q1,TM2Q2,ZJ,IFLQ,IFLQB,
     &PHIFL(0:9,0:2),DBETAZ
      INTEGER NHBOOK
      PARAMETER (NHBOOK=100000)
      REAL BLANC
      COMMON /PAWC/ BLANC(NHBOOK)

C--       functions
      REAL PLU,RLU
      
C--       local variables
      INTEGER LEPIN,INTER,NSIM,NBIN,ISTAT,I,J,ICYCLE,NPRINT
      REAL PPIN,PLEPIN,PTCUT,TOT,BINSIZ(20)

C--       AROMA parameters:

C--       Min pt for produced Q (and Qbar)
      PTCUT=0.
      PARHFL(4)=PTCUT**2
C--       Heavy flavour treatment (D=2): 0->normal events, no heavy flavours
C--       1->normal events + heavy flavours, 2->only heavy flavours.
      LSTHFL(1)=2
C--       Lightest and heaviest flavour to be produced in NC (D=4,5)
      LSTHFL(2)=4
      LSTHFL(3)=5
C--       CC flavour switch: Ics + 10*Icb + 100*Its + 1000*Itb (D=11).
      LSTHFL(6)=11
C--       QCD for HFL events: 1->ME, 2-> ME+PS
      LSTHFL(8)=2

C--       Strange, charm, bottom, top quark masses 
      PMAS(3,1)=0.5
      PMAS(4,1)=1.35
      PMAS(5,1)=5.0
      PMAS(6,1)=175.0

C--      Specify hard kinematical cuts (Q2->0 only for heavy flavour production)
      CUTHFL(1)=0.05
      CUTHFL(2)=0.95
      CUTHFL(3)=0.0
      CUTHFL(4)=100.
      CUTHFL(5)=0.001
      CUTHFL(6)=0.1
      CUTHFL(7)=0.001
      CUTHFL(8)=0.999
      
C--       Incoming proton momentum
      PPIN=820.
C--       Incoming electron momentum
      PLEPIN=-27.5
C--       Lepton type: 11->e-, -11->e+.
      LEPIN=-11
C--       Interaction: 1->EM, 2->CC, 3->Weak NC, 4->NC (EM+weak)
      INTER=4

C--       LEPTO switches
C--       Fragmentation: 0->off, 1->on
      LST(7)=1
C--       Deactivate scattered lepton.
      LST(4)=0
C--       Str. functs.: 
C--       1,2->EHLQ 1,2; 3,4->DO 1,2; 5,10->CTEQ2 M,MS,MF,ML,L,D
      LST(15)=9
C--       Specify soft kinematical cuts
      CUT(1)=0.
      CUT(2)=1.
      CUT(7)=0.
      CUT(8)=1.E6
      CUT(9)=0.
      CUT(10)=1.E6
      CUT(11)=0.
      CUT(12)=1.E6

C--       Number of simulated events
      NSIM=1000

C--       book diagrams
      NBIN=100
      BINSIZ(1)=15./REAL(NBIN)
      BINSIZ(2)=15./REAL(NBIN)
      BINSIZ(3)=1./REAL(NBIN)
      BINSIZ(4)=350./REAL(NBIN)
      BINSIZ(5)=250./REAL(NBIN)
      BINSIZ(6)=5./REAL(NBIN)
      BINSIZ(7)=1./REAL(NBIN)
      BINSIZ(8)=360./REAL(NBIN)
      BINSIZ(9)=25./REAL(NBIN)
      BINSIZ(10)=100./REAL(NBIN)
      BINSIZ(11)=100./REAL(NBIN)
      BINSIZ(12)=1./REAL(NBIN)
      CALL HLIMIT(NHBOOK)
      CALL HROPEN(1,'DUMMY','arodem.hbook','N',1024,ISTAT)
      CALL HBOOK1(1,'dsigma/d(log(Q**2)) ',NBIN,-10.,5.,0.)
      CALL HBOOK1(2,'dsigma/dlogx        ',NBIN,-15.,0.,0.)
      CALL HBOOK1(3,'dsigma/dy           ',NBIN,0.,1.,0.)
      CALL HBOOK1(4,'dsigma/dW           ',NBIN,0.,350.,0.)
      CALL HBOOK1(5,'dsigma/dsqrt(shat)  ',NBIN,0.,250.,0.)
      CALL HBOOK1(6,'dsigma/dlogx_g      ',NBIN,-5.,0.,0.)
      CALL HBOOK1(7,'dsigma/dz           ',NBIN,0.,1.,0.)
      CALL HBOOK1(8,'dsigma/dphi         ',NBIN,0.,360.,0.)
      CALL HBOOK1(9,'dsigma/dpt          ',NBIN,0.,25.,0.)
      CALL HBOOK1(10,'dsigma/dmt1**2     ',NBIN,0.,100.,0.)
      CALL HBOOK1(11,'dsigma/dmt2**2     ',NBIN,0.,100.,0.)
      CALL HBOOK1(12,'1/Nev*dN/dzj       ',NBIN,0.,1.,0.)

C--       initialise AROMA
      CALL AROINI(0,LEPIN,PLEPIN,PPIN,INTER)
      
      NPRINT=RLU(0)*(NSIM-10)+5

C--       generate NSIM events

      DO 10 I=1,NSIM

C--       simulate an event according to the crossection
      CALL AROMA
      IF(LST(21).NE.0) THEN
        WRITE(6,*) ' LST(21) = ',LST(21)
        GOTO 10
      ENDIF
      
      IF(I.EQ.NPRINT) CALL LULIST(1)
      
C--       Analyse generated event.
      CALL HF1(1,LOG10(Q2),1.)
      CALL HF1(2,LOG10(X),1.)
      CALL HF1(3,Y,1.)
      CALL HF1(4,SQRT(W2),1.)
      CALL HF1(5,SQRT(SHAT),1.)
      CALL HF1(6,LOG10(ETA),1.)
      CALL HF1(7,Z,1.)
      CALL HF1(8,PHIQQ*180./3.1416,1.)
      CALL HF1(9,SQRT(PT2Q),1.)
      CALL HF1(10,TM2Q1,1.)
      CALL HF1(11,TM2Q2,1.)
      CALL HF1(12,ZJ,1.)

10    CONTINUE

C--       Finalise histos and write output

      TOT=PARHFL(6)
      IF(LSTHFL(1).EQ.0) TOT=PARL(24)
      IF(LSTHFL(1).EQ.1) TOT=PARL(24)+PARHFL(6) 
      WRITE(6,*) 'Heavy flavour cross-section',PARHFL(6)
      DO 40 I=1,11
         CALL HOPERA(I,'+',I,I,TOT/REAL(NSIM)/BINSIZ(I),0.)
40    CONTINUE
      I=12
      CALL HOPERA(I,'+',I,I,1./REAL(NSIM)/BINSIZ(I),0.)

      CALL HROUT(0,ICYCLE,'T')
      CALL HREND('DUMMY')
      CLOSE(1)

      END
