CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                                      C
C       Monte Carlo for Heavy Flavour Events in ep Collisions          C
C                                                                      C
C                             A R O M A                                C
C                                                                      C
C                  version 2.2.1, April 29, 1996                       C
C                                                                      C
C   Authors:                                                           C
C   Gunnar Ingelman, DESY theory group, ingelman@desy.de               C
C   Johan Rathsman, Dept. of Radiation Sciences, rathsman@tsl.uu.se    C
C   Gerhard Schuler, CERN theory division, schulerg@afsmail.cern.ch    C
C                                                                      C
C   Availability: on request or via the WWW on                         C
C                 http://www3.tsl.uu.se/thep/aroma/                    C
C                                                                      C
C   Manual: DESY preprint 96-058                                       C
C                                                                      C
C   Please report any problems or suggestions for improvements.        C
C                                                                      C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C***********************************************************************

      BLOCK DATA ARODAT
      COMMON /HFDATA/ PARHFL(10),CUTHFL(8),LSTHFL(10)
      REAL*8 PARHFL,CUTHFL
      INTEGER LSTHFL
      DATA PARHFL/0.,0.2,1000.,7*0./
      DATA CUTHFL/0.,1.,0.,1.E9,0.,0.9999999,0.,1./
      DATA LSTHFL/2,4,5,4,0,11,4,2,4,0/
      END

C***********************************************************************

      SUBROUTINE AROINI(LFILE,LEPIN,PLZ,PPZ,INTER)

C--        Calls to: LINIT, HFINIT

C--        Called by: USER

C--        Functions used:


      COMMON /HFDATA/ PARHFL(10),CUTHFL(8),LSTHFL(10)
      REAL*8 PARHFL,CUTHFL
      INTEGER LSTHFL
      REAL*8 DHFSIG,DHFERR
CJR-     added common block for masses in double precision
      REAL*8 DHFS,DMASE,DMASP,DMAS,DEE,DEP
      COMMON /HFJRDM/ DHFS,DMASE,DMASP,DMAS(6)
      COMMON /LINTEG/ NTOT,NPASS
      COMMON /LINTRL/ PSAVE(3,4,5),KSAVE(4),XMIN,XMAX,YMIN,YMAX,
     &Q2MIN,Q2MAX,W2MIN,W2MAX,ILEP,INU,IG,IZ
      COMMON /LEPTOU/ CUT(14),LST(40),PARL(30),X,Y,W2,Q2,U
      COMMON /LINTER/ PARI(40),EWQC(2,2,8),QC(8),ZL(2,4),ZQ(2,8),PQ(17)
      COMMON /LGRID/ NXX,NWW,XX(20),WW(15),PQG(20,15,3),PQQB(20,15,2),
     &QGMAX(20,15,3),QQBMAX(20,15,2),YCUT(20,15),XTOT(20,15),NP
      COMMON /LOPTIM/ OPTX(4),OPTY(4),OPTQ2(4),OPTW2(4),COMFAC
      COMMON/LUJETS/N,K(4000,5),P(4000,5),V(4000,5)
      COMMON/LUDAT1/MSTU(200),PARU(200),MSTJ(200),PARJ(200)
      COMMON/LUDAT2/KCHG(500,3),PMAS(500,4),PARF(2000),VCKM(4,4)
      DOUBLE PRECISION DBETA
      COMMON /LBOOST/ DBETA(2,3),STHETA(2),SPHI(2),PB(5),PHIR
      COMMON /LMINUI/ XKIN(4),UKIN(4),WKIN(4),AIN(4),BIN(4),
     &MAXFIN,RELUP,RELERR,RELER2,FCNMAX
      COMMON /LPFLAG/ LST3
      COMMON /LYPARA/ IPY(80),PYPAR(80),PYVAR(80)

      REAL*8 DEPSIL
      COMMON /HFMACH/ DEPSIL

      REAL*8 DL2MIN,DW2MIN,DYMAX

      WRITE(6,1000) LEPIN,PLZ,PARL(1),PARL(2),PPZ,INTER

      IF(CUTHFL(3).LT.4.) WRITE(6,1110) CUTHFL(3)
      IF(CUTHFL(3).LT.1.) THEN
        WRITE(6,1120) CUTHFL(3)
        IF(LSTHFL(1).EQ.0) THEN
          WRITE(6,*) ' No heavy flavours wanted, execution stopped!'
          STOP
        ENDIF
        IF(LSTHFL(1).EQ.1) LSTHFL(1)=2
      ENDIF


CJR--     calculate machine epsilon
      DEPSIL=1.D0
      DO 1 N=1,10000
         IF(1.D0+DEPSIL.EQ.1.D0) GOTO 2
         DEPSIL=DEPSIL/2.D0
1     CONTINUE
2     DEPSIL=DEPSIL*1.D0
      WRITE(6,1130) DEPSIL


      LSTHFL(4)=INTER
      WRITE(6,1140) LSTHFL(4)
      IF (LSTHFL(1).EQ.2) THEN
         LST(10)=0
         LST(2)=3
      ENDIF
C--       heaviest flavour in BGF
C...Derived parameters:
C...------------------
C...Max flavour in sea structure functions, massless boson-gluon fusion
C...and parton showers in normal events; to avoid double counting!
C...Standard suggestion, may depend on intented study.
C...Alternative: IFLMAX=3 and all heavier flavours treated specially.
      IFLMAX=LSTHFL(2)-1
      IF(INTER.EQ.2) THEN
        IFLMAX=3
        IF(LSTHFL(6).EQ.1) IFLMAX=2
        IF(MOD(LSTHFL(6),1000).EQ.0) IFLMAX=4
      ENDIF
      IHQMIN=IFLMAX+1
      LST(12)=IFLMAX
      LST(13)=IFLMAX
CJR--  NUMBER OF FLAVOURS IN CASCADES
      IPY(8)=IFLMAX
      MSTJ(45)=IFLMAX

C--      initialize masses etc in double presicion
      DMASE=ULMASS(LEPIN)
      DMASP=ULMASS(2212)
      DO 19 I=1,6
         DMAS(I)=PMAS(I,1)
19    CONTINUE
      DEE=SQRT(DBLE(PLZ)**2+DMASE**2)
      DEP=SQRT(DBLE(PPZ)**2+DMASP**2)

CJR--     CMS energy taking masses into account
      DHFS=DMASE**2+DMASP**2+2.D0*(DEE*DEP-DBLE(PLZ)*DBLE(PPZ))

CJR--     calculate effective Q2_max from y_max and cms energy
      DL2MIN=(2.D0*DMAS(IHQMIN))**2+4.D0*PARHFL(4)
      DW2MIN=MAX((2.D0*DMAS(IHQMIN)+DMASP)**2-DMASP**2,
     &           (2.D0*DMAS(IHQMIN))**2+4.D0*PARHFL(4))
      CUTHFL(4)=MIN(CUTHFL(4),CUTHFL(2)*DHFS-DW2MIN)

CJR--     calculate effective y_min and y_max from DW2_min and electron mass
      DYMAX=(DHFS+DW2MIN+SQRT((DHFS-DW2MIN)**2-4.D0*DMASE**2*DW2MIN))/
     /2.D0/(DHFS+DMASE**2)
      CUTHFL(2)=MIN(CUTHFL(2),DYMAX)
      CUTHFL(1)=MAX(CUTHFL(1),DW2MIN/DYMAX/(DHFS+DMASE**2))

CJR--     calculate effective y_min from Q2_min and heavy quark masses
      CUTHFL(1)=MAX(CUTHFL(1),(CUTHFL(3)+DW2MIN)/DHFS)

CJR--     calculate effective Q2_min from y_min and electron mass
      CUTHFL(3)=MAX(CUTHFL(3),
     &DMASE**2*CUTHFL(1)**2/(1.D0-CUTHFL(1)))

CJR--     calculate effective eta_min from Q2_min, pt2_min and y_max
      CUTHFL(5)=MAX(CUTHFL(5),(CUTHFL(3)+DL2MIN)/CUTHFL(2)/DHFS)

CJR--     calculate effective z_max from y_max, Q2_min, pt2_min and eta_max
      CUTHFL(8)=MIN(CUTHFL(8),
     &0.5D0*(1.D0+SQRT(1.D0-DL2MIN/
     /(CUTHFL(6)*CUTHFL(2)*DHFS-CUTHFL(3)))))
      CUTHFL(7)=MAX(CUTHFL(7),
     &DL2MIN/(CUTHFL(6)*CUTHFL(2)*DHFS-CUTHFL(3))/4.D0/CUTHFL(8))

CJR--     write hard cuts into lepto common
      CUT(3)=CUTHFL(1)
      CUT(4)=CUTHFL(2)
      CUT(5)=CUTHFL(3)
      CUT(6)=CUTHFL(4)

      LST(3)=1
      IF (LSTHFL(1).LE.1) LST(3)=3
      LST(8)=LSTHFL(8)+10
      IF (LSTHFL(8).EQ.1) LST(8)=1
      IF (LSTHFL(8).LT.1 .OR. LSTHFL(8).GT.4) THEN
         WRITE(6,*) 'LSTHFL(8)=',LSTHFL(8),'not in allowed range'
         STOP
      ENDIF
      WRITE(6,*) 'LEPTO initialisation:'
CJR--     no grid for photoproduction
      IF (CUT(5).LT.1.0) LST(19)=-1
      CALL LINIT(LFILE,LEPIN,PLZ,PPZ,INTER)
      IF (LSTHFL(1).EQ.2) THEN
         LST(2)=1
      ENDIF

      IF(LSTHFL(1).GT.0) THEN
C...Initialize proper heavy flavour simulation.
        LSTHFL(5)=-LEPIN
        CALL HFINIT(IFAIL,DHFSIG,DHFERR)
        PARHFL(1)=DHFSIG
        IF(IFAIL.NE.0) THEN
          WRITE(6,*) ' Warning: HFINIT failed with IFAIL = ',IFAIL
          STOP
        ENDIF
      ENDIF

      RETURN

 1000 FORMAT(' ',//,5X,
     &'AROMA -- Monte Carlo for Heavy Flavour Events in ep Collisions',
     &/,5X,62('='),/,10X,
     &'version 2.2.1, April 29 , 1996, using LEPTO 6.5',//,
     &' Lepton: type =',I3,5X,'momentum (pz) =',F8.1,
     &' GeV/c',//,' Target: A, Z =',2F3.0,2X,
     &'momentum (pz) =',F8.1,' GeV/c',//,
     &' Interaction :',I3,//)
 1110 FORMAT(' Warning: Q2MIN =',F6.2,
     &' < 4, too small for normal DIS.',/)
 1120 FORMAT(' Warning: Q2MIN =',F6.2,
     &' < 1, normal DIS switched  off.',/)
 1130 FORMAT(' Machine epsilon: ',G12.4,/)
 1140 FORMAT(' LSTHFL(4) set by AROINI to: ',I2,//)
      END


C***********************************************************************

      SUBROUTINE HFINIT(IFAIL,SIG,ERREST)

C  Initialize Heavy Flavour Monte Carlo                                C
C                                                                      C
C  Set up the grid for event generation                                C
C                                                                      C
C  SIG contains the NC or CC cross section.                            C
C  Return with IFAIL=0 if proper initialized.                          C
C  Return with IFAIL=7 if LSTHFL(6) out of bounds and LSTHFL(4)=2      C
C  Return with IFAIL=6 if PARL(6) out of bounds                        C
C  Return with IFAIL=5 if LST(15) out of bounds                        C
C  Return with IFAIL=4 if LSTHFL(4) out of bounds                      C
C  Return with IFAIL=3 if WUR negativ (should not occur)               C
C  Return with IFAIL=2 if NOT:                                         C
C       4 <= minimal flavour <= maximal flavour  for the NC case       C
C       3 <= minimal flavour <= maximal flavour  for the CC case       C
C  Return with IFAIL=1 if cms-energy too small for lightest flavour.   C
C                                                                      C
C  Input: - minimal flavour in LSTHFL(2)                               C
C         - maximal flavour in LSTHFL(3)                               C
C         - e(+) scattering: LSTHFL(5)>0;   e(-): LSTHFL(5)<=0         C
C         - total cms energy in PARL(21)                               C
C         - choice of exchanged boson in LSTHFL(4)                     C
C   (0) full NC; (1) photon; (2) Z; (3) interference; (4) W            C
C         - longitudinal lepton polarization in PARL(6)                C
C         - choice of W-process in LSTHFL(6) =                         C
C                   n(cs) + 10*n(cb) + 100*n(ts) + 1000*n(tb)          C
C     where n(ab)=1 if aWb is enabled, and n(ab)=0 if aWb is disabled  C
C                                                                      C
C            NO SPECIAL TREATMENT OF S-QUARK MASS SO FAR               C
C                                                                      C
C  Output: YNCMIN,YNCMAX,DL2MIN,W2MIN,HFA,HFV,HFVU,HFAU,HFVD,HFAD,XMZ  C
C                                                                      C
C  Used : function PMAS; PARL(5); YMIN,YMAX, ...                       C
C                                                                      C

C--        Calls to: PARTN, INTGRL

C--        Called by:

C--        Functions used:

C
C  Input variables:
C            none
C  Output variables:
      REAL*8 SIG, ERREST
      INTEGER IFAIL
C  Local variables:
      REAL*8 AW2MAX,QMSSMA,HFS,SINTW2,SINTW,COSTW,
     &       CHIZ,  HFV,HFA,HFVU,HFAU,HFVD,HFAD
C  Variables in COMMON /HFBLi/
      REAL*8 CCPL11, CCPL44, XMW, CHIW,
     &       XMZ,UCP4GZ,DCP4GZ,UCP4ZZ,DCP4ZZ,
     &       UCPLGG,DCPLGG,UCPLGZ,DCPLGZ,UCP1ZZ,DCP1ZZ,UCP2ZZ,DCP2ZZ
C  Functions used
C                    none
C  Variables for DIVON4
      REAL SPRDMX, XMINUS(4), XPLUS(4), ERROR, ANS
C  Common block of DIVON4
      COMMON /BNDLMT/ FLOW,FHIGH
      COMMON /SAMPLE/ NPOINT
C  Internal used common blocks
      COMMON /HFBL1/ IFLON(8,8)
      COMMON /HFBL2/ XMZ,UCP4GZ,DCP4GZ,UCP4ZZ,DCP4ZZ,CCPL11,CCPL44,XMW,
     &       UCPLGG,DCPLGG,UCPLGZ,DCPLGZ,UCP1ZZ,DCP1ZZ,UCP2ZZ,DCP2ZZ
     &       , CHIW
C  Common blocks of LEPTO
      COMMON /LINTRL/ PSAVE(3,4,5),KSAVE(4),XMIN,XMAX,YMIN,YMAX,
     &Q2MIN,Q2MAX,W2MIN,W2MAX,ILEP,INU,IG,IZ
      COMMON /LEPTOU/ CUT(14),LST(40),PARL(30),AAX,AAY,AAW2,AAQ2,AAU
C  Common blocks of LUND
      COMMON/LUDAT2/KCHG(500,3),PMAS(500,4),PARF(2000),VCKM(4,4)
C
CJR-     added common block for masses in double precision
      REAL*8 DHFS,DMASE,DMASP,DMAS
      COMMON /HFJRDM/ DHFS,DMASE,DMASP,DMAS(6)
      COMMON /HFDATA/ PARHFL(10),CUTHFL(8),LSTHFL(10)
      REAL*8 PARHFL,CUTHFL
      INTEGER LSTHFL
C AW2MAX = W1**2 for heaviest quark
C AW2MIN = W1**2 for lightest quark
C QMSSMA = mass of heaviest quark
C QMSSMI = mass of lightest quark
C HFS = total cms energy
C DL2MIN = minimal shat (=delta**2) for lightest quark
C YNCMAX = maximal Y in the NC case for lightest quark
C YNCMIN = minimal Y in the NC case for lightest quark
C HFV = vector coupling of electron
C HFA = axial vector coupling of electron
C HFVU = vector coupling of up-like quark
C HFAU = axial vector coupling of up-like quark
C HFVD = vector coupling of down-like quark
C HFAD = axial vector coupling of down-like quark
C XMZ = mass of Z-boson
C SIG = Estimate of total cross section
C ERREST = Estimate of error of total cross section
C
C
      SIG = 0.D0
      IFAIL = 0
      ERREST = 0.D0
      WRITE(6,1000) (LSTHFL(I),I=1,9),(CUTHFL(I),I=1,8),(CUT(I),I=1,2),
     &(CUT(I),I=7,14),PARHFL(2),PARHFL(3),SQRT(PARHFL(4)),
     &(DMAS(I),I=3,6)
C
C
C  check condition on flavour number
C
CJR      NNNN = 4
CJR      IF (LSTHFL(4).EQ.2) NNNN = 3
CJR      IF (LSTHFL(2).LT.NNNN .OR. LSTHFL(3).LT.LSTHFL(2)) THEN
      IF (LSTHFL(3).LT.LSTHFL(2)) THEN
         IFAIL = 2
         WRITE(6,1002) LSTHFL(2), LSTHFL(3)
         RETURN
      ENDIF
C
C  check condition on gluon density
C
      IF (LST(15).LT.1 .OR. LST(15).GT.10) THEN
         IFAIL = 5
         WRITE(6,1005) LST(15)
         RETURN
      ENDIF
C
C  check condition on exchanged boson
C
      IF (LSTHFL(4).LT.1 .OR. LSTHFL(4).GT.4) THEN
         IFAIL = 4
         WRITE(6,1004) LSTHFL(4)
         RETURN
      ENDIF
C
C  check condition on polarization
C
      IF (PARL(6).LT.-1. .OR. PARL(6).GT.1.) THEN
         IFAIL = 6
         WRITE(6,1006) PARL(6)
         RETURN
      ENDIF
C
C  Check if cms energy is big enough for the lightest flavour
C
      DO 2 I=LSTHFL(2),LSTHFL(3)
CJR      QMSSMA = PMAS(I,1 )
      QMSSMA = DMAS(I)
      AW2MAX = (QMSSMA+QMSSMA+DMASP)**2 - DMASP**2
CJR      HFS = PARL(21)
      HFS = DHFS
      IF (HFS + 2.D0*DMASE**2 -
     &              2.D0*DSQRT(DMASE**2*(HFS+DMASE**2))
     &    - AW2MAX  .LE. 0.D0 ) THEN
         WRITE(6,*) ' Warning from HFINIT: cms energy too low for ',
     &   'flavour = ',I,' of mass = ',QMSSMA
         LSTHFL(3)=I-1
         IF(I.EQ.LSTHFL(2)) THEN
           IFAIL = 1
           WRITE(6,1001) QMSSMA
           IF(LSTHFL(1).EQ.2) STOP
           RETURN
         ENDIF
      ENDIF
    2 CONTINUE
C
C  Set internal array for W-exchange:
C
      IF (LSTHFL(4).EQ.2 .AND. LSTHFL(6).LE.0) THEN
        WRITE(6,1007) LSTHFL(6)
        IFAIL=7
        RETURN
      ENDIF
      DO 333 ILOOP1=1,8
       DO 333 ILOOP2=1,8
  333  IFLON(ILOOP1,ILOOP2)=0
      IFLON(6,5) = LSTHFL(6)/1000
       ION1 = LSTHFL(6) - IFLON(6,5)*1000
      IFLON(6,3) = ION1/100
       ION2 = ION1 - IFLON(6,3)*100
      IFLON(4,5) = ION2/10
       ION1 = ION2 - IFLON(4,5)*10
      IFLON(4,3) = ION1
      IF (  ( IFLON(4,3)*(IFLON(4,3)-1) )**2
     1    + ( IFLON(4,5)*(IFLON(4,5)-1) )**2
     2    + ( IFLON(6,3)*(IFLON(6,3)-1) )**2
     3    + ( IFLON(6,5)*(IFLON(6,5)-1) )**2   .NE. 0) THEN
        WRITE(6,1007) LSTHFL(6)
        IFAIL=7
        RETURN
      ENDIF
C
C  Define the couplings and the Z-boson mass:
C
      SINTW2 = PARL(5)
      SINTW  = DSQRT(SINTW2)
      COSTW  = DSQRT(1.D0 - SINTW2)
      HFV = -1.D0 + 4.D0*SINTW2
      HFA = -1.D0
      HFVU = + 1.D0 - 8.D0/3.D0*SINTW2
      HFAU = + 1.D0
      HFVD = - 1.D0 + 4.D0/3.D0*SINTW2
      HFAD = - 1.D0
      XMW = 38.6815D0 / SINTW
      XMZ = XMW / COSTW
      CHIZ = 16.D0*SINTW2*COSTW**2
      CHIW = 8.D0*SINTW2
      UCPLGG = 4.D0/9.D0
      DCPLGG = 1.D0/9.D0
      ILEPTN = 1
      IF (LSTHFL(5) .GT. 0) ILEPTN = -1
C
C  NC couplings
C  g_{11}^u = UCPLGG + UCPLGZ*PROP(Q2) + UCP1ZZ*PROP(Q2)**2
C  g_{12}^u = UCPLGG + UCPLGZ*PROP(Q2) + UCP2ZZ*PROP(Q2)**2
C  g_{11}^d = DCPLGG + DCPLGZ*PROP(Q2) + DCP1ZZ*PROP(Q2)**2
C  g_{12}^d = DCPLGG + DCPLGZ*PROP(Q2) + DCP2ZZ*PROP(Q2)**2
C  g_{44}^u =          UCP4GZ*PROP(Q2) + UCP4ZZ*PROP(Q2)**2
C  g_{44}^d =          DCP4GZ*PROP(Q2) + DCP4ZZ*PROP(Q2)**2
C  where PROP(Q2) = 1.D0/( 1.D0 + XMZ**2/Q2 )
C
      UCPLGZ = 2.D0 *  2.D0/3.D0 * HFVU /CHIZ * ( -HFV + ILEPTN*
     &                                           PARL(6) * HFA )
      DCPLGZ = 2.D0 *(-1.D0/3.D0)* HFVD /CHIZ * ( -HFV + ILEPTN*
     &                                           PARL(6) * HFA )
      UCP1ZZ = (HFVU**2+HFAU**2)/CHIZ**2 *( HFV**2 + HFA**2 -
     &                                ILEPTN*2.D0*HFV*HFA*PARL(6) )
      DCP1ZZ = (HFVD**2+HFAD**2)/CHIZ**2 *( HFV**2 + HFA**2 -
     &                                ILEPTN*2.D0*HFV*HFA*PARL(6) )
      UCP2ZZ = (HFVU**2-HFAU**2)/CHIZ**2 *( HFV**2 + HFA**2 -
     &                                ILEPTN*2.D0*HFV*HFA*PARL(6) )
      DCP2ZZ = (HFVD**2-HFAD**2)/CHIZ**2 *( HFV**2 + HFA**2 -
     &                                ILEPTN*2.D0*HFV*HFA*PARL(6) )
      UCP4GZ = 2.D0 * 2.D0/3.D0 * HFAU * ( -ILEPTN*HFA + HFV*PARL(6) )
     &                                 / CHIZ
      DCP4GZ =2.D0* (-1.D0/3.D0)* HFAD * ( -ILEPTN*HFA + HFV*PARL(6) )
     &                                 / CHIZ
      UCP4ZZ = 2.D0 * HFVU * HFAU * ( ILEPTN*2.D0*HFV*HFA
     &                                   - PARL(6)*(HFV**2 + HFA**2) )
     &                                 / CHIZ**2
      DCP4ZZ = 2.D0 * HFVD * HFAD * ( ILEPTN*2.D0*HFV*HFA
     &                                   - PARL(6)*(HFV**2 + HFA**2) )
     &                                 / CHIZ**2
C
C  CC couplings
      CCPL11 = 4.D0*(1.D0 - ILEPTN*PARL(6)) / CHIW**2
      CCPL44 = 4.D0*(ILEPTN - PARL(6)) / CHIW**2
C
C  Set up the grid and calculate the total cross section:
C
      NDIM=4
      DO 10 I=1,4
      XMINUS(I)=0.E0
   10 XPLUS(I)=1.E0
      NPOINT=200
C
        SPRDMX=PARHFL(2)
        MAXPTS=500000
        CALL PARTN(NDIM,XMINUS,XPLUS,SPRDMX,MAXPTS)
        JDEG=1
        NPT=PARHFL(3)
        CALL INTGRL(NDIM,JDEG,NPT,ANS,ERROR)
        SIG = DBLE(ANS)
        ERREST = DBLE(ERROR)
        WRITE(6,2100) ANS,ERROR
C
      RETURN
 1000 FORMAT(//,' Initialization of AROMA heavy flavour generator',
     &        /,' -----------------------------------------------',
     &/,' Inclusion of heavy flavours           LSTHFL(1) =',I5,
     &/,' Min & max flavour in NC     LSTHFL(2),LSTHFL(3) =',2I5,
     &/,' Included contributions                LSTHFL(4) =',I5,
     &/,' Incoming lepton (internal flag)       LSTHFL(5) =',I5,
     &/,' Flavours included in CC               LSTHFL(6) =',I5,
     &/,' Parton showers; scale in final        LSTHFL(7) =',I5,
     &/,'                 included  ones        LSTHFL(8) =',I5,
     &/,'                 scale in initial      LSTHFL(9) =',I5,/,1P
     &/,' Hard cuts (CUTHFL) +phase space: ',G12.4,' <   Y   < ',G12.4,
     &/,'                                  ',G12.4,' <   Q2  < ',G12.4,
     &/,'                                  ',G12.4,' <  X_G  < ',G12.4,
     &/,'                                  ',G12.4,' <   Z   < ',G12.4,/
     &/,' Soft cuts (CUT):                 ',G12.4,' <   X   < ',G12.4,
     &/,'                                  ',G12.4,' <   W2  < ',G12.4,
     &/,'                                  ',G12.4,' <   U   < ',G12.4,
     &/,'                                  ',G12.4,' <   E   < ',G12.4,
     &/,'                                  ',G12.4,' < THETA < ',G12.4,/
     &/,' DIVON precision parameters: PARHFL(2),PARHFL(3) =',2G10.4,
     &/,' Min pt of Q in boson-gluon cms =',G10.4,
     &/,' Quark masses: ms, mc, mb, mt   =',4G10.4,/)
 1001 FORMAT(2X,'cms-energy too small for lightest flavour of mass',
     & F8.2,/)
 1002 FORMAT(2X,'Error in flavour numbers LSTHFL(2) = ',I7,
     & 4X,' LSTHFL(3)= ',I7,/)
 1004 FORMAT(2X,'Wrong choice of exchanged boson: LSTHFL(4) = ',I7,/)
 1005 FORMAT(2X,'Wrong choice of gluon density: LST(15) = ',I7,/)
 1006 FORMAT(2X,'Error in polarization PARL(6) = ',E15.3,/)
 1007 FORMAT(2X,'Error in W-exchange: LSTHFL(6) = ',I7,/)
 2100 FORMAT(//,5X,'Heavy flavour cross section =',1P,E12.3,' pb',
     &        /,5X,'Error estimate from DIVON   =',E12.3,' pb',/)
      END

C***********************************************************************

      SUBROUTINE AROMA

C...Administer the generation of an event.
C...Note that if the error flag LST(21) is not zero, no event has been
C...generated.

C--        Calls to: HFLGEN, LEPTO, LUDBRB

C--        Called by: USER

C--        Functions used:


      COMMON /HFDATA/ PARHFL(10),CUTHFL(8),LSTHFL(10)
      REAL*8 PARHFL,CUTHFL
      INTEGER LSTHFL
      COMMON /LINTRL/ PSAVE(3,4,5),KSAVE(4),XMIN,XMAX,YMIN,YMAX,
     &Q2MIN,Q2MAX,W2MIN,W2MAX,ILEP,INU,IG,IZ
      COMMON /LEPTOU/ CUT(14),LST(40),PARL(30),X,Y,W2,Q2,U
      COMMON /LINTER/ PARI(40),EWQC(2,2,8),QC(8),ZL(2,4),ZQ(2,8),PQ(17)
      COMMON/LUJETS/N,K(4000,5),P(4000,5),V(4000,5)
      COMMON/LUDAT1/MSTU(200),PARU(200),MSTJ(200),PARJ(200)
      COMMON /LBOOST/ DBETA(2,3),STHETA(2),SPHI(2),PB(5),PHIR
CJR-     added common block for masses in double precision
      REAL*8 DHFS,DMASE,DMASP,DMAS
      COMMON /HFJRDM/ DHFS,DMASE,DMASP,DMAS(6)
      DOUBLE PRECISION DBETA

      NTRY=0
    1 LST(21)=0
      NTRY=NTRY+1
      DO 10 I=1,10
      DO 10 J=1,5
      K(I,J)=0
   10 V(I,J)=0.
      DO 15 I=1,4
      K(I,1)=21
   15 K(I,2)=KSAVE(I)
      K(4,1)=1
      N=2
C...Initial state momenta fixed from LINIT call.
      DO 42 I=1,2
      DO 40 J=1,5
   40 P(I,J)=PSAVE(3,I,J)
   42 IF(PSAVE(3,1,3).LT.0.) P(I,3)=-PSAVE(3,I,3)
      LST(28)=3

      IF(LST(2).GT.0.AND.(LSTHFL(1).EQ.2.OR.
     &(LSTHFL(1).EQ.1.AND.
     &RLU(0)*(PARL(23)+PARHFL(1)).LT.PARHFL(1)))) THEN
C...Generate heavy flavour event.  (assume proton target)
        LST(22)=1
        IHF=1
CJR          LST(24)=3 reqired for HFMEPS to work
        LST(24)=3
        CALL HFLGEN
        IF (LST(21).EQ.999) GOTO 1
        IF(LST(21).NE.0) THEN
CJR          WRITE(6,*) ' Error flag LST(21) =',LST(21)
          IF(NTRY.LT.10) THEN
CJR            WRITE(6,*) ' New event generated.'
            GOTO 1
          ELSE
            WRITE(6,*) ' Too many errors, back to user program.'
            RETURN
          ENDIF
        ENDIF
        LST(24)=5
      ELSE
C--       generate normal LEPTO-event
        CALL LEPTO
        IF(LST(21).NE.0) THEN
CJR          WRITE(6,*) ' Error flag LST(21) =',LST(21)
          IF(NTRY.LT.10) THEN
CJR            WRITE(6,*) ' New event generated.'
            GOTO 1
          ELSE
            WRITE(6,*) ' Too many errors, back to user program.'
            RETURN
          ENDIF
        ENDIF
      ENDIF

      RETURN
      END

C***********************************************************************

      SUBROUTINE HFLGEN

C...Administer heavy flavour generation based on exact matrix elements.

C--        Calls to: RANGEN, HFVECT, LUDBRB, LSHOWR, HFCHCK, HFTOTD,
C--                  LREMH,  LPRIKT, LUPREP, HFMEPS,  LUEXEC, LFRAME,
C--                  LSCI,   LSMALL

C--        Called by: AROMA

C--        Functions used: LUCOMP, ULMASS, ULANGL, RLU


      IMPLICIT NONE

C--       global variables
      REAL*8 PARHFL,CUTHFL
      INTEGER LSTHFL
      COMMON /HFDATA/ PARHFL(10),CUTHFL(8),LSTHFL(10)
C14...new COMMON blocks needed
      DOUBLE PRECISION DX,DQ2,DW2,DY,DS,DETA,DSHAT
      COMMON /HFSNCO/ DX,DQ2,DW2,DY,DS,DETA,DSHAT
      INTEGER IPY
      REAL PYPAR,PYVAR
      COMMON /LYPARA/ IPY(80),PYPAR(80),PYVAR(80)
      INTEGER ISUB,KFL,XPY,SH,TH,UH,Q2PY,XSEC
      COMMON /LYPROC/ ISUB,KFL(3,2),XPY(2),SH,TH,UH,Q2PY,XSEC(0:40)
C14
      INTEGER N,K
      REAL P,V
      COMMON/LUJETS/N,K(4000,5),P(4000,5),V(4000,5)
      INTEGER MSTU,MSTJ
      REAL PARU,PARJ
      COMMON/LUDAT1/MSTU(200),PARU(200),MSTJ(200),PARJ(200)
      INTEGER KCHG
      REAL PMAS,PARF,VCKM
      COMMON/LUDAT2/KCHG(500,3),PMAS(500,4),PARF(2000),VCKM(4,4)
CJR-     added common block for masses in double precision
      REAL*8 DHFS,DMASE,DMASP,DMAS
      COMMON /HFJRDM/ DHFS,DMASE,DMASP,DMAS(6)
      REAL CUT,PARL,X,Y,W2,Q2,U
      INTEGER LST
      COMMON /LEPTOU/ CUT(14),LST(40),PARL(30),X,Y,W2,Q2,U
      REAL PSAVE,XMIN,XMAX,YMIN,YMAX,Q2MIN,Q2MAX,W2MIN,W2MAX
      INTEGER KSAVE,ILEP,INU,IG,IZ
      COMMON /LINTRL/ PSAVE(3,4,5),KSAVE(4),XMIN,XMAX,YMIN,YMAX,
     &Q2MIN,Q2MAX,W2MIN,W2MAX,ILEP,INU,IG,IZ
      DOUBLE PRECISION DBETA
      REAL STHETA,SPHI,PB,PHIR
      COMMON /LBOOST/ DBETA(2,3),STHETA(2),SPHI(2),PB(5),PHIR
      REAL CABIBO
      COMMON /LFLMIX/ CABIBO(4,4)
      REAL SHAT,ETA,Z,PHIQQ,PT2Q,TM2Q1,TM2Q2,ZJ,PHIFL
      INTEGER IFLQ,IFLQB
      REAL*8 DBETAZ
      COMMON /HFLVAR/ SHAT,ETA,Z,PHIQQ,PT2Q,TM2Q1,TM2Q2,ZJ,IFLQ,IFLQB,
     &PHIFL(0:9,0:2),DBETAZ
      INTEGER IFLON
      COMMON /HFBL1/ IFLON(8,8)

C--       functions
      INTEGER LUCOMP
      REAL ULMASS,ULANGL,RLU

C--       local variables
      DOUBLE PRECISION DE,DPZ,DPT,DETOT
      DOUBLE PRECISION DXPS(4),SIGPHI(0:2),DZ,DWT
      DOUBLE PRECISION SFLPHI(0:9,0:2)
      DOUBLE PRECISION SG,RFL,SFL,PHIMAX,THAT,EPZ,AMTQ
      DOUBLE PRECISION AMTQQ,T3,SM1,SM2,EP,Q0,EL,E1,E2,Q1
      DOUBLE PRECISION COSBET,SINBET,COSTHE,SINTHE
      DOUBLE PRECISION XT,TM2TQQ,TM2TQ,DPHIQQ
      REAL S,THETA,PHI,ARGUM,PTPRI,PHIPRI,THETAL,PT,PHIT,PT2,ZZZZ
      REAL XPS(4)
      INTEGER NEV,NPR,IUP,IDOWN,IFLAVU,IFLAVD,NLOOP,I,IFAIL,J
      INTEGER IFL,IIFL,IFL1,IFL2,IFLTQ,IFLTQQ,NREMH,NS
      DOUBLE PRECISION EF,PF,VX,VY,VZ
      DOUBLE PRECISION DTRIED,DACCEP
      SAVE DTRIED,DACCEP
      EF(VX,VY,VZ)=(VX+VY-VZ)/(2.D0*SQRT(VX))
      PF(VX,VY,VZ)=DSQRT(MAX(0.D0,
     &(VX**2+VY**2+VZ**2-2.D0*(VX*VY+VX*VZ+VY*VZ))/(4.D0*VX)))
      DATA NEV,NPR/0,0/,IFL1,IFL2/0,0/,DTRIED,DACCEP/2*0.D0/

      NEV=NEV+1

      IF (LSTHFL(4).EQ.2) THEN
C...CC interaction.
        DO 5 IUP=4,8,2
        DO 5 IDOWN=3,7,2
        IF (IFLON(IUP,IDOWN).NE.0) THEN
          IFLAVU=IUP
          IFLAVD=IDOWN
          GOTO 6
        ENDIF
    5   CONTINUE
        WRITE(6,*) ' Error (HFLGEN): improper flavours.'
        LST(21)=901
        RETURN
    6   CONTINUE
      ELSE
C...NC interaction.
        IFLAVU = LSTHFL(2)
        IFLAVD = IFLAVU
      ENDIF

      NLOOP=0
   10 NLOOP=NLOOP+1
      DTRIED=DTRIED+1.D0
      IF(NLOOP.GT.100) THEN
        LST(21)=902
        RETURN
      ENDIF
      CALL RANGEN(4,XPS)
      DO 11 I=1,4
   11 DXPS(I)=XPS(I)
      CALL HFVECT(DXPS,IFLAVU,IFLAVD,DY,DQ2,DETA,DZ,IFAIL,DWT)
      IF(IFAIL.NE.0) THEN
CF        WRITE(6,*) ' Warning (HFLGEN): HFVECT failed, IFAIL =',IFAIL
        GOTO 10
      ENDIF
      Y=DY
      Q2=DQ2
CJR      DS=PARL(21)
      DS=DHFS
CJR      S=PARL(21)
      S=DHFS
      DSHAT=DY*DETA*DS-Q2
      SHAT=DSHAT
      ETA=DETA
      Z=DZ
      DX=DQ2/(DY*DS)
      X=DX
      SG=DETA*DS
      PARL(22)=DY*(DHFS-DMASE**2-DMASP**2)
      U=PARL(22)/(2.*P(2,5))
C14
      DW2=(1.D0-DX)*DY*DS
C14
      W2=PARL(22)*(1.D0-DX)+DBLE(P(2,5))**2
C--       Formulae for massive particles
      DE=(-DBLE(P(1,3))*(1.D0-DY)*(DBLE(P(1,4))*DBLE(P(2,4))-
     - DBLE(P(1,3))*DBLE(P(2,3)))+DBLE(P(2,3))*(DMASE**2+DQ2/2.D0))/
     / (DBLE(P(1,4))*DBLE(P(2,3))-DBLE(P(1,3))*DBLE(P(2,4)))
      P(4,4)=SNGL(DE)
      DPZ=(DBLE(P(1,4))*(1.D0-DY)*(DBLE(P(1,4))*DBLE(P(2,4))-
     - DBLE(P(1,3))*DBLE(P(2,3)))-DBLE(P(2,4))*(DMASE**2+DQ2/2.D0))/
     / (DBLE(P(1,3))*DBLE(P(2,4))-DBLE(P(1,4))*DBLE(P(2,3)))
      DPT=DE**2-DPZ**2-DMASE**2
      IF(DPT.LT.0.D0) GOTO 20
      DPT=DSQRT(DPT)
      IF(LST(2).EQ.3) GOTO 30
      IF(X.LT.CUT(1).OR.X.GT.CUT(2))  THEN
CJR         WRITE(6,*) 'X, XMIN, XMAX',X,CUT(1),CUT(2)
         GOTO 20
      ENDIF
      IF(Y.LT.CUT(3).OR.Y.GT.CUT(4))  THEN
CJR         WRITE(6,*) 'Y, YMIN, YMAX',Y,CUT(3),CUT(4)
         GOTO 20
      ENDIF
      IF(Q2.LT.CUT(5).OR.Q2.GT.CUT(6))  THEN
CJR         WRITE(6,*) 'Q2, Q2MIN, Q2MAX',Q2,CUT(5),CUT(6)
         GOTO 20
      ENDIF
      IF(W2.LT.CUT(7).OR.W2.GT.CUT(8))  THEN
CJR         WRITE(6,*) 'W2, W2MIN, W2MAX',W2,CUT(7),CUT(8)
         GOTO 20
      ENDIF
      IF(U.LT.CUT(9).OR.U.GT.CUT(10))  THEN
CJR         WRITE(6,*) 'U, UMIN, UMAX',U,CUT(9),CUT(10)
         GOTO 20
      ENDIF
C...Transform scattered lepton back to lab system to make cut
C...in energy and angle (defined as space angle to incoming lepton).
      K(6,1)=0
      K(6,2)=KSAVE(4)
      P(6,1)=SNGL(DPT)
      P(6,2)=0.
      P(6,3)=SNGL(DPZ)
      P(6,4)=SNGL(DE)
      P(6,5)=ULMASS(LUCOMP(KSAVE(4)))
      N=6
      MSTU(1)=6
CJR divide boost
      THETA=STHETA(1)
      PHI=SPHI(1)
      CALL LUDBRB(6,N,THETA,0.,0.D0,0.D0,0.D0)
      CALL LUDBRB(6,N,0.,PHI,0.D0,0.D0,0.D0)
      CALL LUDBRB(6,N,0.,0.,DBETA(1,1),DBETA(1,2),DBETA(1,3))
      MSTU(1)=0
      N=2
      IF(P(6,4).LT.CUT(11).OR.P(6,4).GT.CUT(12)) THEN
CJR         WRITE(6,*) 'E-cut failed in hflgen, E ,EMIN,EMAX'
CJR     ,              ,P(6,4),CUT(11),CUT(12)
         GOTO 20
      ENDIF
C...Check argument is within range.
      ARGUM=(PSAVE(3,1,1)*P(6,1)+PSAVE(3,1,2)*P(6,2)+
     +PSAVE(3,1,3)*P(6,3))/
     &SQRT(PSAVE(3,1,1)**2+PSAVE(3,1,2)**2+PSAVE(3,1,3)**2)/
     &SQRT(P(6,1)**2+P(6,2)**2+P(6,3)**2)
      IF(ABS(ARGUM).GT.1.01) WRITE(6,*) 'Warning (HFLGEN): ARGUM=',ARGUM
      IF(ABS(ARGUM).GT.1.) ARGUM=SIGN(1.,ARGUM)
      THETAL=ACOS(ARGUM)
      IF(THETAL.LT.CUT(13).OR.THETAL.GT.CUT(14))  THEN
CJR         WRITE(6,*) 'THETA-cut failed in hflgen, THETA ,TMIN,TMAX'
CJR     ,              ,THETAL,CUT(13),CUT(14)
         GOTO 20
      ENDIF
C...Cuts passed.
      GOTO 30
C...Kinematical variables failed cuts.
20    CONTINUE
CJR      WRITE(6,*) ' HFLGEN: Choosen kinematical variables failed cuts.'
      IF (LSTHFL(1).EQ.1) THEN
CJR--   special treatment in case of mixing LEPTO and AROMA events
         LST(21)=999
         RETURN
      ENDIF
      GOTO 10
   30 CONTINUE
CJR--     update efficiency ratio
      DACCEP=DACCEP+1.D0
      PARHFL(5)=DACCEP/DTRIED
      PARHFL(6)=PARHFL(1)*PARHFL(5)
C...Scattered lepton and exchanged virtual boson added to event record.
      K(4,1)=1
      K(4,2)=KSAVE(4)
      K(4,3)=1
      P(4,1)=SNGL(DPT)
      P(4,2)=0.
      P(4,3)=SNGL(DPZ)
      P(4,4)=SNGL(DE)
      P(4,5)=ULMASS(K(4,2))
      P(3,1)=-P(4,1)
      P(3,2)=0.
      P(3,3)=P(1,3)-P(4,3)
      P(3,4)=P(1,4)-P(4,4)
      P(3,5)=-SQRT(Q2)
      K(1,1)=21
      K(2,1)=21
      K(3,1)=21
      K(3,3)=1
      N=4

C...Transform to lepton-nucleon cms if not made earlier
      IF(LST(17).EQ.0) THEN
        DO 46 I=3,4
        DO 45 J=1,5
   45   PSAVE(3,I,J)=P(I,J)
   46   IF(PSAVE(3,1,3).LT.0.) PSAVE(3,I,3)=-P(I,3)
        CALL LUDBRB(0,0,0.,0.,0.D0,0.D0,-DBETA(1,3))
        LST(28)=2
      ENDIF
      DO 47 I=1,4
      DO 47 J=1,5
   47 PSAVE(2,I,J)=P(I,J)

C...Prepare for parton cascade.
      IF(LSTHFL(8).GE.2) CALL LSHOWR(0)

      IF(NEV.LE.NPR) CALL LULIST(1)

C...Transform to hadronic cms, boost parameters in double precision.
      DETOT=DBLE(P(1,4))-DBLE(P(4,4))+DBLE(P(2,4))
      DBETA(2,1)=-DBLE(P(4,1))/DETOT
      DBETA(2,2)=-DBLE(P(4,2))/DETOT
      DBETA(2,3)=(DBLE(P(1,3))-DBLE(P(4,3))+DBLE(P(2,3)))/DETOT
      CALL LUDBRB(0,0,0.,0.,-DBETA(2,1),-DBETA(2,2),-DBETA(2,3))
      SPHI(2)=0.
      STHETA(2)=ULANGL(P(3,3),P(3,1))
      CALL LUDBRB(0,0,-STHETA(2),0.,0.D0,0.D0,0.D0)

      IF(NEV.LE.NPR) CALL LULIST(1)

      LST(28)=1
      DO 48 I=1,4
      DO 48 J=1,5
   48 PSAVE(1,I,J)=P(I,J)

C...Choose flavour.
      DO 50 I=0,9
      DO 50 J=0,2
   50 SFLPHI(I,J)=0.
      IF (LSTHFL(4).EQ.2) THEN
C...CC interaction.
        I=0
        DO 60 IFLAVU=4,8,2
        DO 60 IFLAVD=3,7,2
        I=I+1
        IF (IFLON(IFLAVU,IFLAVD).EQ.0) GOTO 60
        CALL HFCHCK(IFLAVU,IFLAVD,DY,DQ2,DETA,DZ,IFAIL)
        IF (IFAIL .NE. 0) GOTO 60
        CALL HFTOTD(DY,DQ2,DETA,DZ,IFLAVU,IFLAVD,SIGPHI)
        DO 55 J=0,2
   55   SFLPHI(I,J)=SIGPHI(J)*DWT*CABIBO(IFLAVU/2,(IFLAVD+1)/2)
        SFLPHI(0,0)=SFLPHI(0,0)+SFLPHI(I,0)
   60   CONTINUE
      ELSE
C..NC interaction.
        DO 90 IFL=LSTHFL(2),LSTHFL(3)
CGS
        CALL HFCHCK(IFL,IFL,DY,DQ2,DETA,DZ,IFAIL)
        IF(IFAIL.NE.0) GOTO 91
        IF(IFL.EQ.0) GOTO 90
        CALL HFTOTD(DY,DQ2,DETA,DZ,IFL,IFL,SIGPHI)
        IIFL=IFL
        DO 80 J=0,2
   80   SFLPHI(IIFL,J)=SIGPHI(J)*DWT
        SFLPHI(0,0)=SFLPHI(0,0)+SIGPHI(0)*DWT
CGS
   90   CONTINUE
   91   CONTINUE
      ENDIF
      DO 92 I=0,9
      DO 92 J=0,2
   92 PHIFL(I,J)=SFLPHI(I,J)
      RFL=RLU(0)*SFLPHI(0,0)
      SFL=0.
CGS
      I=0
   95 I=I+1
      SFL=SFL+SFLPHI(I,0)
      IF(RFL.GT.SFL) GOTO 95
      IF(LSTHFL(4).EQ.2) THEN
C...CC case
        IF(I.LE.3) THEN
          IFL1=4
        ELSEIF(I.LE.6) THEN
          IFL1=6
        ELSEIF(I.LE.9) THEN
          IFL1=8
        ENDIF
        IF(I.EQ.1.OR.I.EQ.4.OR.I.EQ.7) THEN
          IFL2=3
        ELSEIF(I.EQ.2.OR.I.EQ.5.OR.I.EQ.8) THEN
          IFL2=5
        ELSEIF(I.EQ.3.OR.I.EQ.6.OR.I.EQ.9) THEN
          IFL2=7
        ENDIF
        IF(IFLON(IFL1,IFL2).EQ.0) THEN
          WRITE(6,*) 'Warning (HFLGEN): choosen flavours not allowed, ',
     &    'IFLU, IFLD = ',IFL1,IFL2
          GOTO 10
        ENDIF
        IFLQ=IFL1
        IFLQB=-IFL2
        IF(K(3,2).LT.0) THEN
C...W- exchange, flip quark-antiquark.
          IFLQ=IFL2
          IFLQB=-IFL1
        ENDIF
      ELSE
C...NC case
CGS
           IFLQ=I
           IFLQB=-IFLQ
           IFL1=IFLQ
           IFL2=IFLQB
           IF(IFLQ.LT.LSTHFL(2).OR.IFLQ.GT.LSTHFL(3)) THEN
        WRITE(6,*) ' Warning: choosen flavour out of range, IFL1= ',IFL1
           GOTO 10
           ENDIF
CGS
      ENDIF

C...Choose azimuthal angle between lepton and hadron planes.
      PHIMAX=ABS(SFLPHI(I,0))+ABS(SFLPHI(I,1))+ABS(SFLPHI(I,2))
  100 DPHIQQ=6.2832*RLU(0)
      IF(SFLPHI(I,0)+SFLPHI(I,1)*COS(DPHIQQ)+
     &SFLPHI(I,2)*COS(2.*DPHIQQ).LT.RLU(0)*PHIMAX) GOTO 100
      PHIQQ=DPHIQQ
      T3=-SG+DSHAT+DQ2
CGS
      THAT=DMAS(IFLQ)**2-DZ*DY*SG
      SM1=DMAS(IFLQ)**2
      SM2=DMAS(-IFLQB)**2

      EP=EF(DSHAT,0.D0,-DQ2)
      Q0=EF(DSHAT,-DQ2,0.D0)
      EL=(SG-DQ2)/(2.D0*DSQRT(DSHAT))
CGS
      E1=EF(DSHAT,SM1,SM2)
      E2=EF(DSHAT,SM2,SM1)
      Q1=PF(DSHAT,SM1,SM2)
CGS
      COSBET=((2.*EP*EL-SG)/(2*EP*EL))
      IF(ABS(COSBET).GE.1.) THEN
        IF(ABS(COSBET)-1..GT.1.E-03) WRITE(6,*) ' Warning: COSBET = ',
     &  COSBET
        COSBET=SIGN(1.D0,COSBET)
        SINBET=0.
      ELSE
        SINBET=SQRT(1.D0-COSBET**2)
      ENDIF
      IF(Q1.GT.0.) THEN
        COSTHE=((2.*EP*E1-SM1+THAT)/(2.*EP*Q1))
        SINTHE=SQRT(1.-COSTHE**2)
      ELSE
        COSTHE=0.
        SINTHE=1.
      ENDIF
C...Save quark pt**2 & mt**2
      PT2Q=(Q1*SINTHE)**2
      TM2Q1=PT2Q+SM1
      TM2Q2=PT2Q+SM2
      ZJ=0.5+(SM1-SM2)/(2.*DSHAT)+Q1*COSTHE/SQRT(DSHAT)

C...4-vectors in parton-parton cms.
C...Produced quark. in row 5
      K(N+1,1)=2
      K(N+1,2)=IFLQ
      P(N+1,1)=Q1*SINTHE*COS(DPHIQQ)
      P(N+1,2)=Q1*SINTHE*SIN(DPHIQQ)
      P(N+1,3)=Q1*COSTHE
      P(N+1,4)=E1
      P(N+1,5)=PMAS(IABS(IFLQ),1)
C...Produced antiquark. in row 7
      K(N+3,1)=1
      K(N+3,2)=IFLQB
      P(N+3,1)=-P(N+1,1)
      P(N+3,2)=-P(N+1,2)
      P(N+3,3)=-P(N+1,3)
      P(N+3,4)=E2
      P(N+3,5)=PMAS(-IFLQB,1)
C...Exchanged boson. in row 9 only for testing purposes
      K(N+5,1)=21
      K(N+5,2)=K(3,2)
      P(N+5,1)=0.
      P(N+5,2)=0.
      P(N+5,3)=-EP
      P(N+5,4)=Q0
      P(N+5,5)=-SQRT(DQ2)
C...Scattered lepton. in row 10 only for testing purposes
      K(N+6,1)=21
      K(N+6,2)=KSAVE(4)
      P(N+6,1)=EL*SINBET
      P(N+6,2)=0.
      P(N+6,3)=EL*COSBET+EP
      P(N+6,4)=EL-Q0
      P(N+6,5)=ULMASS(LUCOMP(K(N+6,2)))
C...Initial gluon or quark.  in row 11 only for testing purposes
      K(N+7,1)=21
      K(N+7,2)=21
      P(N+7,1)=0.
      P(N+7,2)=0.
      P(N+7,3)=EP
      P(N+7,4)=EP
      P(N+7,5)=PMAS(21,1)
      EPZ=2.*EP/DETA
C...Target remnant; split into qq + q
C...Choose target valence quark/diquark to form jet system with
C...produced antiquark/quark.
      IF (LSTHFL(8).LE.1) THEN
         IFLTQ=INT(1.+1./3.+RLU(0))
         IFLTQ=3-IFLTQ
         IF(IFLTQ.EQ.2) THEN
           IFLTQQ=2101
           IF(RLU(0).GT.PARL(4)) IFLTQQ=2103
         ELSE
           IFLTQQ=2203
         ENDIF
CJR--        reduction of constituent masses
         AMTQQ=ULMASS(IFLTQQ)-2.*PARL(20)
         AMTQ=ULMASS(IFLTQ)-PARL(20)
         NREMH=0
310      NREMH=NREMH+1
         IF(NREMH.GT.100) THEN
            LST(21)=903
            RETURN
         ENDIF
         PT=0.
         PHIT=0.
C--    give pT in target remnant split
         CALL LPRIKT(PARL(14),PT,PHIT)
         PT2=PT**2
         TM2TQQ=AMTQQ**2+PT2
         TM2TQ=AMTQ**2+PT2
         CALL LREMH(0,PT,IFLTQQ,IFLTQ,ZZZZ)
         IF (ZZZZ.EQ.0 .OR. ZZZZ.EQ.1.0) THEN
C             WRITE(6,*) 'XT=0 or 1'
             GOTO 310
         ENDIF
         XT=ZZZZ
         EPZ=(1.-DETA)*EPZ
C...Target remnant diquark. in row 6
         K(N+2,1)=1
         K(N+2,2)=IFLTQQ
         P(N+2,1)=PT*COS(PHIT)
         P(N+2,2)=PT*SIN(PHIT)
         P(N+2,3)=0.5*((1.D0-XT)*EPZ-TM2TQQ/(1.D0-XT)/EPZ)
         P(N+2,4)=0.5*((1.D0-XT)*EPZ+TM2TQQ/(1.D0-XT)/EPZ)
         P(N+2,5)=AMTQQ
C...Target remnant quark. in row 8
         K(N+4,1)=1
         K(N+4,2)=IFLTQ
         P(N+4,1)=-P(N+2,1)
         P(N+4,2)=-P(N+2,2)
         P(N+4,3)=0.5*(XT*EPZ-TM2TQ/XT/EPZ)
         P(N+4,4)=0.5*(XT*EPZ+TM2TQ/XT/EPZ)
         P(N+4,5)=AMTQ
C--   correct string information
         K(N+3,1)=2
      ELSE
CJR--     target remnat replaced by gluon in row 6
         K(N+2,1)=2
         K(N+2,2)=21
         K(N+2,3)=2
         P(N+2,1)=0.
         P(N+2,2)=0.
         P(N+2,3)=0.5*EPZ-EP
         P(N+2,4)=0.5*EPZ-EP
         P(N+2,5)=PMAS(21,1)
      ENDIF
      NS=N
      N=N+7
      LST(26)=NS+1
      IF(NEV.LE.NPR) WRITE(6,*) 'HFLGEN  3: 1-4 b-P, 5-8 b-g cms '
      IF(NEV.LE.NPR) CALL LULIST(1)

C...Boost to hadronic cms, i.e. boson-proton cms, boson along +z axis.
C...Part 1. From boson-gluon cms.
      DBETAZ=(1.D0-DETA)/(1.D0+DETA*Q0/EP)
      CALL LUDBRB(NS+1,N,0.0,0.0,0.D0,0.D0,-DBETAZ)
      IF(NEV.LE.NPR) WRITE(6,*) 'HFLGEN  4: 1-4 b-P cms '
      IF(NEV.LE.NPR) CALL LULIST(1)
C...If incoming proton along -z axis, rotate system.
      IF(P(2,3)*P(NS+2,3).LT.0.) THEN
         CALL LUDBRB(NS+1,N,3.1415927,0.0,0.D0,0.D0,0.D0)
         IF(NEV.LE.NPR) WRITE(6,*) 'HFLGEN  6:  b-P cms, pz <---> -pz '
         IF(NEV.LE.NPR) CALL LULIST(1)
      ENDIF
C14
C...Exclude row 8-11 in cascade case and 9-11 in ME case
      IF (LSTHFL(8).GT.1) THEN
         N=N-4
      ELSE
         N=N-3
      ENDIF
      DO 408 I=N+1,11
         DO 409 J=1,5
            K(I,J)=0
            P(I,J)=0.
            V(I,J)=0.
409      CONTINUE
408   CONTINUE
C...Save momentum of exchanged boson (used in subroutine LFRAME).
      DO 410 J=1,5
  410 PB(J)=P(3,J)

C14

CJR--       no preclustering of small systems
          MSTJ(14)=-1
CJR--            

      IF(LSTHFL(8).LE.1) THEN
C...No parton cascade, introduce primordial kt.
        IF(PARL(3).GT.1.E-03) THEN
          CALL LPRIKT(PARL(3),PTPRI,PHIPRI)
          CALL LUDBRB(LST(26),LST(26)+3,0.0,-PHIPRI,0.D0,0.D0,0.D0)
          CALL LUDBRB(LST(26),LST(26)+3,ATAN(2.*PTPRI/SQRT(W2)),
     &    PHIPRI,0.D0,0.D0,0.D0)
        ENDIF
C...Check system against fragmentation cuts.
        MSTU(24)=0
        CALL LUPREP(0)
        IF(MSTU(24).NE.0) THEN
          IF(LST(3).GE.1) WRITE(6,*) ' LUPREP error MSTU(24)= ',MSTU(24)
          LST(21)=904
          RETURN
        ENDIF
      ELSE
C...Include parton cascades (+ remnant & kt) on qqbar-event
        CALL HFMEPS
        IF (LST(21).NE.0) RETURN
      ENDIF
      IF(NEV.LE.NPR) WRITE(6,*) 'HFLGEN  : after HFMEPS'
      IF(NEV.LE.NPR) CALL LULIST(1)

CJR--     Soft Colour Interactions
      IF(LST(34).EQ.1) CALL LSCI(PARL(7))
      IF(LST(21).NE.0) RETURN
CJR--       take care of small systems
      CALL LSMALL
      IF(LST(21).NE.0) THEN
        IF(LST(3).GE.1) WRITE(6,*)' LSMALL error LST(21)= ',LST(21),
     &                            ', New event generated'
        RETURN
      ENDIF
      MSTJ(14)=1
      CALL LUPREP(0)
      IF(MSTU(24).NE.0) THEN
         IF(LST(3).GE.1) WRITE(6,*)' LUPREP error MSTU(24)= ',MSTU(24),
     &                             ', New event generated'
         LST(21)=905
         RETURN
      ENDIF
CJR--            

C--       boost back to lab

      DO 500 I=1,N
      DO 500 J=1,5
  500 V(I,J)=0.
      IF(LST(7).EQ.1) THEN
        CALL LUEXEC
        IF(MSTU(24).NE.0) THEN
          WRITE(6,*) ' Error from JETSET, new event made'
          LST(21)=MSTU(24)
          RETURN
        ENDIF
      ENDIF

C     CALL GULIST(-1,2)
C...Transform to desired frame
C     LST(28)=1
      LST(29)=0
      PHIR=6.2832*RLU(0)
      IF(LST(17).EQ.0) THEN
        IF(LST(5).GE.2) CALL LFRAME(LST(5),0)
C...Restore momenta (e,p,boson,L) due to numerical errors from boosts
CJR        DO 600 I=1,4
CJR        DO 600 J=1,5
CJR  600   P(I,J)=PSAVE(LST(28),I,J)
        IF(LST(6).EQ.1.AND.LST(28).GE.2) THEN
C...Random rotation in azimuthal angle
          CALL LUDBRB(0,0,0.,PHIR,0.D0,0.D0,0.D0)
          LST(29)=1
        ENDIF
      ELSE
        IF(LST(5).GE.2) CALL LFRAME(LST(5),LST(6))
      ENDIF
C...Deactivate scattered lepton
      IF(MOD(LST(4),10).EQ.0) K(4,1)=21
C     CALL GULIST(0,2)

      IF(NEV.LE.NPR) WRITE(6,*) 'HFLGEN  : back to user'
      IF(NEV.LE.NPR) CALL LULIST(1)

      LST(21)=0
      RETURN
      END

C***********************************************************************

      SUBROUTINE DVNOPT

C         Change DIVON default options

C--        Calls to: -

C--        Called by: Divonne

C--        Functions used:


      COMMON /D151DT/ IDATE
      REAL*8 IDATE
      COMMON /PRINT/ IPRINT
      COMMON /ISTRGE/ MXRGNS , ISTOR(12000)
      COMMON /RSTRGE/ RSTSZE,RSTOR(18001)
      INTEGER RSTSZE
      COMMON /QUADRE/ IDEG
      COMMON /START/ ISTART
      COMMON /EXFILE/ NFILE
      COMMON /DISPOS/ IDISP
      COMMON /DEPTHS/ ISTDPH , INCDPH
      COMMON /SAMPLE/ NPOINT
      COMMON /CUTOLS/ BNDTOL, FRACT, REGNTL, FNLTOL
      COMMON /BNDLMT/ FLOBD,FUPBD
      COMMON /PRSTOP/ NSTOP
      COMMON /ZEETRM/ ITRMF
C
      IPRINT=10
      IDEG=1
C
      WRITE(6,*) ' DIVON4 DEFAULT OPTIONS ARE ALTERED BY USER.'
      RETURN
      END

C***********************************************************************

      DOUBLE PRECISION FUNCTION DFUN(NDIM,X)

C  Interface for DIVONN4

C--        Calls to:

C--        Called by: Divonne

C--        Functions used: HFFUNC

      INTEGER NDIM
      DOUBLE PRECISION X(NDIM), HFFUNC

      DFUN=HFFUNC(X)
      RETURN
      END

C***********************************************************************

      DOUBLE PRECISION FUNCTION HFFUNC(X)

C                                                                      C
C  total NC or CC cross section for heavy flavour (sum over flavours)  C
C  sets the phase bounds for the lightest flavour                      C
C  appropriate for MC integration                                      C
C  LSTHFL(4) determines the exchanged boson:(0) full NC, (1) pure      C
C  photon; (2) Z; (3) interference; (4) W.                             C
CJR changed to be the same as INTER (and LEPTO)                        C
C  LSTHFL(4) determines the exchanged boson:                           C
C  (1) pure photon;                                                    C
C  (2) W;                                                              C
C  (3) pure Z;                                                         C
C  (4) full NC.                                                        C

C--        Calls to: HFVECT, HFCHCK, HFTOTD

C--        Called by: DFUN

C--        Functions used:

C  function arguments
      REAL*8 X(4)
C  local variables
      REAL*8 DY, DQ2, DETA, DZ, HFSG(0:2), WT
C  Common blocks of LEPTO
      COMMON /LEPTOU/ CUT(14),LST(40),PARL(30),AAX,AAY,AAW2,AAQ2,AAU
      COMMON /LFLMIX/ CABIBO(4,4)
C  Internal used common block
      COMMON /HFBL1/ IFLON(8,8)
C
      COMMON /HFDATA/ PARHFL(10),CUTHFL(8),LSTHFL(10)
      REAL*8 PARHFL,CUTHFL
      INTEGER LSTHFL
C
C
      HFFUNC = 0.D0
      IFAIL = 0
      IFLAVU = LSTHFL(2)
      IFLAVD = IFLAVU
C
C  find lightest quark pair for W-exchange
C
      IF (LSTHFL(4).EQ.2) THEN
        DO 333 IUP=4,8,2
          DO 333 IDOWN=3,7,2
          IF (IFLON(IUP,IDOWN).NE.0) THEN
            IFLAVU=IUP
            IFLAVD=IDOWN
            GOTO 334
          ENDIF
 333    CONTINUE
C  SHOULD NEVER !!!!!!!!!!!!!!!!!!!!! OCCUR !!!!!!!!!!!!!!!!!!!!!!!!!!!
      WRITE(6,*) '********** Catastrophic error in HFFUNC ***********'
        RETURN
 334    CONTINUE
      ENDIF
C
C  Set up the grid
C
      CALL HFVECT(X,IFLAVU,IFLAVD,DY,DQ2,DETA,DZ,IFAIL,WT)
      IF (IFAIL.NE.0) THEN
CJR         WRITE(6,*) 'HFVECT FAILED IN HFFUNC, IFAIL=',IFAIL
         RETURN
      ENDIF
C
C  NC loop
C
      IF (LSTHFL(4).NE.2) THEN
C
        DO 10 IFLAV=LSTHFL(2),LSTHFL(3)
        CALL HFCHCK(IFLAV,IFLAV,DY,DQ2,DETA,DZ,IFAIL)
        IF (IFAIL .NE. 0) RETURN
        CALL HFTOTD(DY,DQ2,DETA,DZ,IFLAV,IFLAV,HFSG)
  10    HFFUNC = HFFUNC + HFSG(0) * WT
C
      ELSE
C
C  CC loop
C
        DO 12 IFLAVU=4,8,2
        DO 12 IFLAVD=3,7,2
C
          IF (IFLON(IFLAVU,IFLAVD).EQ.0) GOTO 11
          CALL HFCHCK(IFLAVU,IFLAVD,DY,DQ2,DETA,DZ,IFAIL)
          IF (IFAIL .NE. 0) RETURN
          CALL HFTOTD(DY,DQ2,DETA,DZ,IFLAVU,IFLAVD,HFSG)
          HFFUNC = HFFUNC + HFSG(0) * WT
     &       * CABIBO( IFLAVU/2, (IFLAVD+1)/2 )
  11      CONTINUE
  12    CONTINUE
C
      ENDIF
C
C
      RETURN
      END

C***********************************************************************

      SUBROUTINE HFVECT(XX,IFLAVU,IFLAVD,DY,DQ2,DETA,DZ,IFAIL,WT)
C                                                                      C
C  Makes the transformation between X(4) and Y,Q2,ETA,Z                C
C          for the specific flavour chosen by IFLAV.                   C
C  For different exchange (defined in LSTHFL(4) )                      C
C          different generation of variables are used.                 C
C  Returns with IFAIL <> 0 in case of error due to numerical           C
C  uncertainties. Then set function to zero or reject, respectively.   C
C  WT is the weight for the specific transformation.                   C

C--        Calls to: HFVCT1, HFVCT2, LUDBRB

C--        Called by: HFFUNC, HFLGEN

C--        Functions used:

      IMPLICIT NONE

C  input variables
      REAL*8 XX(4)
      INTEGER IFLAVU,IFLAVD
C  output variables
      REAL*8 DY,DQ2,DETA,DZ,WT
      INTEGER IFAIL
C  Common blocks of JETSET
      INTEGER N,K
      REAL P,V
      COMMON /LUJETS/ N,K(4000,5),P(4000,5),V(4000,5)
CJR-     added common block for masses in double precision
      REAL*8 DHFS,DMASE,DMASP,DMAS
      COMMON /HFJRDM/ DHFS,DMASE,DMASP,DMAS(6)
      REAL*8 PARHFL,CUTHFL
      INTEGER LSTHFL
      COMMON /HFDATA/ PARHFL(10),CUTHFL(8),LSTHFL(10)

      DOUBLE PRECISION DE,DPZ,DPT
      INTEGER J

CJR-     transform from closed to open intervall
      REAL*8 DEPSIL
      COMMON /HFMACH/ DEPSIL
C
      DO 10 J=1,4
         XX(J)=(XX(J)+DEPSIL)*(1.D0-2.D0*DEPSIL)
10    CONTINUE


C  reference to LSTHFL(4),HFVCT1,HFVCT2
C
      IF (LSTHFL(4).EQ.4 .OR. LSTHFL(4).EQ.1) THEN
C  full NC and pure photon case and IFLAVU should be equal to IFLAVD
         CALL HFVCT1(XX,IFLAVU,DY,DQ2,DETA,DZ,IFAIL,WT)
C
      ELSE
C  Z or W case
         CALL HFVCT2(XX,IFLAVU,IFLAVD,DY,DQ2,DETA,DZ,IFAIL,WT)
      ENDIF
      IF(IFAIL.NE.0) RETURN
C
C  Check hard cuts and pt
C
C--       Formulae for massive particles
      DE=(-DBLE(P(1,3))*(1.D0-DY)*(DBLE(P(1,4))*DBLE(P(2,4))-
     - DBLE(P(1,3))*DBLE(P(2,3)))+DBLE(P(2,3))*(DMASE**2+DQ2/2.D0))/
     / (DBLE(P(1,4))*DBLE(P(2,3))-DBLE(P(1,3))*DBLE(P(2,4)))
      P(4,4)=SNGL(DE)
      DPZ=(DBLE(P(1,4))*(1.D0-DY)*(DBLE(P(1,4))*DBLE(P(2,4))-
     - DBLE(P(1,3))*DBLE(P(2,3)))-DBLE(P(2,4))*(DMASE**2+DQ2/2.D0))/
     / (DBLE(P(1,3))*DBLE(P(2,4))-DBLE(P(1,4))*DBLE(P(2,3)))

      DPT=DE**2-DPZ**2-DMASE**2
      IF(SNGL(DPT).LT.0.) THEN
CJR         WRITE(6,*) 'HFVECT: PT=',SNGL(DPT)
         IFAIL=8
         RETURN
      ENDIF
      DPT=DSQRT(DPT)
      IF(DY.LT.CUTHFL(1).OR.DY.GT.CUTHFL(2))  THEN
CJR      WRITE(6,*) 'HFVECT: Y, YMIN, YMAX',DY,CUTHFL(1),CUTHFL(2)
         IFAIL=8
         RETURN
      ENDIF
      IF(DQ2.LT.CUTHFL(3).OR.DQ2.GT.CUTHFL(4))  THEN
CJR      WRITE(6,*) 'HFVECT: Q2, Q2MIN, Q2MAX',DQ2,CUTHFL(3),CUTHFL(4)
         IFAIL=8
         RETURN
      ENDIF
      IF(DETA.LT.CUTHFL(5).OR.DETA.GT.CUTHFL(6))  THEN
CJR      WRITE(6,*) 'HFVECT: ETA, ETAMIN, ETAMAX',DETA,CUTHFL(5),CUTHFL(6)
         IFAIL=8
         RETURN
      ENDIF
      IF(DZ.LT.CUTHFL(7).OR.DZ.GT.CUTHFL(8))  THEN
CJR      WRITE(6,*) 'HFVECT: Z, ZMIN, ZMAX',DZ,CUTHFL(7),CUTHFL(8)
         IFAIL=8
         RETURN
      ENDIF

      RETURN
      END

C***********************************************************************

      SUBROUTINE HFCHCK(IFLAVU,IFLAVD,Y,Q2,ETA,Z,IFAIL)
C                                                                      C
C  To check if (Y,Q2,ETA,Z) are out of bounds for given flavour IFLAV. C
C  Returns with IFAIL <> 0 if out of bounds.                           C
C                                                                      C

C--        Calls to: -

C--        Called by: HFFUNC, HFLGEN

C--        Functions used:


C  input variables
      REAL*8 Y,Q2,ETA,Z
      INTEGER IFLAVU,IFLAVD
C  output variables
      INTEGER IFAIL
C  internal use variables
      REAL*8 DY,DQ2,DETA,DZ
      REAL*8 QMSSMU,DW2MIN,DL2MIN,HFS,WUR,YNCMIN,YNCMAX,DQ2MIN,DQ2MAX,
     &       ETAMIN,DZMIN,DZMAX,SHAT,XGAM2,XLAM,QMSSMD,QMASS
C  Common blocks of LUND
      COMMON/LUDAT2/KCHG(500,3),PMAS(500,4),PARF(2000),VCKM(4,4)
C  Common blocks of LEPTO
      COMMON /LINTRL/ PSAVE(3,4,5),KSAVE(4),XMIN,XMAX,YMIN,YMAX,
     &Q2MIN,Q2MAX,W2MIN,W2MAX,ILEP,INU,IG,IZ
      COMMON /LEPTOU/ CUT(14),LST(40),PARL(30),AAX,AAY,AAW2,AAQ2,AAU
C  Common blocks of AROMA
      COMMON /HFDATA/ PARHFL(10),CUTHFL(8),LSTHFL(10)
      REAL*8 PARHFL,CUTHFL
      INTEGER LSTHFL
CJR-     added common block for masses in double precision
      REAL*8 DHFS,DMASE,DMASP,DMAS
      COMMON /HFJRDM/ DHFS,DMASE,DMASP,DMAS(6)
C
      IFAIL = 5
C
C  quark mass
CJR      QMSSMD = PMAS( IFLAVD,1 )
      QMSSMD = DMAS( IFLAVD )
CJR      QMSSMU = PMAS( IFLAVU,1 )
      QMSSMU = DMAS( IFLAVU )
C  Change for e(+)
      IF (LSTHFL(5).GT.0) THEN
        QMASS = QMSSMD
        QMSSMD = QMSSMU
        QMSSMU = QMASS
      ENDIF
C
C  Define DW2MIN, DL2MIN, HFS
      DW2MIN = (QMSSMU+QMSSMD+DMASP)**2 - DMASP**2
      DL2MIN = (QMSSMU+QMSSMD)**2
CJR      HFS=PARL(21)
      HFS = DHFS
C  Calculate y-cuts
      WUR = 1.D0 - 4.D0*DMASE**2*DW2MIN/(HFS-DW2MIN)**2
C  Reject if out of bounds
      IF (WUR .LE. 0.D0) THEN
         IFAIL = 3
CJR         WRITE(6,1003) WUR
         RETURN
      ENDIF
      WUR = (HFS-DW2MIN)*SQRT(WUR)
CJR      YNCMIN = (HFS+DW2MIN-WUR)/(2.D0*(HFS+DMASE**2))
      YNCMAX = (HFS+DW2MIN+WUR)/(2.D0*(HFS+DMASE**2))
      YNCMIN = DW2MIN/YNCMAX/(HFS+DMASE**2)
C  Reject if out of Y-bounds
      IF (Y.GT.YNCMAX .OR. Y.LT.YNCMIN) RETURN
C  otherwise accept y:
         DY = Y
C  Calculate Q**2 cuts
         DQ2MIN = DMASE**2*DY**2/(1.D0-DY)
         DQ2MAX = DY*HFS-DW2MIN
C  Reject if out of bounds
         IF (  DQ2MAX .LT. DQ2MIN  )  THEN
           IFAIL = 2
CJR           WRITE(6,1002) DQ2MIN,DQ2MAX
           RETURN
         ENDIF
C  check if out of Q2-bounds
      IF (Q2.LT.DQ2MIN .OR. Q2.GT.DQ2MAX) RETURN
C  otherwise accept Q**2
         DQ2 = Q2
C  Define ETAMIN
         ETAMIN = (DQ2 + DL2MIN)/(DY*HFS)
CJR--         take hard cuts into account
         ETAMIN=MAX(ETAMIN,CUTHFL(5))
         ETAMAX=MIN(1.D0,CUTHFL(6))
C  check phase space for eta
         IF (ETAMIN .GT. ETAMAX) RETURN
C  check if ETA out of bounds
      IF (ETA.LT.ETAMIN .OR. ETA.GT.1.D0) RETURN
C  otherwise accept ETA
         DETA = ETA
C..
         SHAT = DETA*DY*HFS - DQ2
C..Takes care of numerical uncertanties.
C..to guarentee that lam in 'DIFSIG' is non-negativ..
         IF (SHAT .LT. DL2MIN) THEN
            IFAIL = 1
CJR            WRITE(6,1001) SHAT
            RETURN
         ENDIF
C
C  Define Z
      IF (IFLAVU .EQ. IFLAVD) THEN
         XGAM2 = SHAT
         XLAM = (SHAT - 2.D0 * QMSSMU**2)**2
     &                 - 4.D0 * QMSSMU**4
      ELSE
         XGAM2 = SHAT + QMSSMD**2 - QMSSMU**2
         XLAM = (SHAT - QMSSMU**2 - QMSSMD**2)**2
     &                 - 4.D0 * QMSSMU**2 * QMSSMD**2
      ENDIF
         DZMIN = (XGAM2-SQRT(XLAM))/(2.D0*SHAT)
         DZMAX = (XGAM2+SQRT(XLAM))/(2.D0*SHAT)
C  check if out of Z-bounds
      IF (Z.LT.DZMIN .OR. Z.GT.DZMAX) RETURN
C  otherwise accept Z
         DZ = Z
C  Reject if out of bounds
      IF (DZ.LT.0.D0 .OR. DZ.GT.1.D0) THEN
         IFAIL = 4
CJR         WRITE(6,1004) DZ
         RETURN
      ENDIF
C
C  accept
      IFAIL = 0
C
 1001 FORMAT(2X,'numerical uncertainty in HFCHCK for SHAT (<0) ',
     & E15.3,/)
 1002 FORMAT(2X,'numerical uncertainty in HFCHCK for Q**2 ',2E15.3,/)
 1003 FORMAT(2X,'numerical uncertainty in HFCHCK for Y (<0) ',
     & E15.3,/)
 1004 FORMAT(2X,'numerical uncertainty in HFCHCK for Z (<0 or >1) ',
     & E15.3,/)
      RETURN
      END


C***********************************************************************

      SUBROUTINE HFTOTD(Y,Q2,ETA,Z,IFLAVU,IFLAVD,HFSG)
C                                                                      C
C  Calculates the individual contributions HFSG(i)                     C
C  of the differential ep -> Q bar{Q} X cross section of flavour IFLAV C
C  according to:                                                       C
C    HFSG(0) + COS(PHI)*HFSG(1) + COS(2*PHI)*HFSG(2)                   C
C  for given values of (y,Q2,eta,z).                                   C

C--        Calls to: LYSTFU

C--        Called by: HFFUNC, HFLGEN

C--        Functions used:

C  function arguments, input:
      REAL*8 Y,Q2,ETA,Z
      INTEGER IFLAVU,IFLAVD
C  output variables
      REAL*8 HFSG(0:2)
C  variables in common blocks
      REAL*8 XMZ,UCP4GZ,DCP4GZ,UCP4ZZ,DCP4ZZ,CCPL11,CCPL44,XMW,CHIW,
     &       UCPLGG,DCPLGG,UCPLGZ,DCPLGZ,UCP1ZZ,DCP1ZZ,UCP2ZZ,DCP2ZZ
C  Local variables
      REAL*8 HFH11,HFH12,HFH14,HFH16,HFH21,HFH22,HFH41,HFH43,
     &       HFG11,HFG12,HFG1A,HFG1B,HFG21,HFG22,HFG3,HFGC,
     &       HFFFF,HFGGG,XG,HFMMI2,HFMPL2,HFM0,XM1,XM2,SG,SHAT,
     &       HFSG01,HFSG02,HFSG03,HFSG11,HFSG13,HFSG21,
     &       HFPROP,XG11,XG12,XG44,PI,HFPRPW, PROPQ1,PROPQ2
C  statement functions:
      DOUBLE PRECISION PROP, PROPW, PROP1, PROP2
C  gluon distribution variables
      REAL RETA,RSHAT,XPQ(-6:6)
      REAL*8 XGETA

C  Common blocks of LUND
      COMMON/LUDAT2/KCHG(500,3),PMAS(500,4),PARF(2000),VCKM(4,4)
      COMMON /LEPTOU/ CUT(14),LST(40),PARL(30),AAX,AAY,AAW2,AAQ2,AAU
CJR-     added common block for masses in double precision
      REAL*8 DHFS,DMASE,DMASP,DMAS
      COMMON /HFJRDM/ DHFS,DMASE,DMASP,DMAS(6)
      COMMON /HFDATA/ PARHFL(10),CUTHFL(8),LSTHFL(10)
      REAL*8 PARHFL,CUTHFL
      INTEGER LSTHFL
C  Internal common blocks
      COMMON /HFBL2/ XMZ,UCP4GZ,DCP4GZ,UCP4ZZ,DCP4ZZ,CCPL11,CCPL44,XMW,
     &       UCPLGG,DCPLGG,UCPLGZ,DCPLGZ,UCP1ZZ,DCP1ZZ,UCP2ZZ,DCP2ZZ
     &       , CHIW

C  statement functions:
      PROP(Q2) = 1.D0/(1.D0 + XMZ**2/Q2)
      PROP1(Q2) = 1.D0/(Q2    + XMZ**2)
      PROPW(Q2) = 1.D0/(1.D0 + XMW**2/Q2)
      PROP2(Q2) = 1.D0/(Q2    + XMW**2)

      PI = 4.D0*DATAN(1.D0)

C  Z = z
C  Y = y
C  XG = x_G
C  HFMMI2 = m_{minus}^2
C  HFMPL2 = m_{plus}^2
C  HFM0 = m_0

C  HFFFF = f(x_G,z;y,s_G)
C  HFGGG = g(x_G,z;y,s_G)
C  HFHij = H^{(i)}_j
C  HFGij = G^{(i)}_j

CJR      XM1 = PMAS(IFLAVD,1)
      XM1 = DMAS(IFLAVD)
CJR      XM2 = PMAS(IFLAVU,1)
      XM2 = DMAS(IFLAVU)
      IF(LSTHFL(5).GT.0.AND.LSTHFL(4).EQ.2) THEN
C...Flip quark masses for e+ CC case.
        XM1SAV=XM1
        XM1=XM2
        XM2=XM1SAV
      ENDIF
CJR      SG = ETA * PARL(21)
      SG = ETA * DHFS
      XG = Q2/(Y*SG)
      SHAT = Y*SG - Q2
      HFMPL2 = (XM1**2 + XM2**2)/(Y*SG)
      HFMMI2 = (XM1**2 - XM2**2)/(Y*SG)
      HFM0 = XM1*XM2/(Y*SG)

C     HFFFF = (1.D0-XG)*Z*(1.D0-Z) + (HFMMI2*(2.D0*Z-1.D0) - HFMPL2)/2.
      HFFFF = (1.D0-XG)*Z*(1.D0-Z) +
     &(HFMMI2*(2.D0*Z-1.D0)-HFMPL2)/2.D0
      HFGGG = (1.D0-XG)*(1.D0-Z) + XG*Z + HFMMI2


      IF (Y.GT.1.D0) WRITE(6,1005) Y
      IF (XG.LT.0.D0) WRITE(6,1006) XG
      IF(HFFFF.LT.0.D0) THEN
          IF(HFFFF.LT.-1.D-10) WRITE(6,1007) HFFFF
          HFFFF = 0.D0
      ENDIF
      IF (Z.LT.0.D0) WRITE(6,1008) Z
      IF (Z.GT.1.D0) WRITE(6,1009) Z


      HFH43 = (8.*(2.*Z**2*XG - Z**2 - 2.*Z*XG + 2.*Z*HFMMI2 + Z -
     . HFMMI2 - HFMPL2))/(Z**2*(Z**2 - 2.*Z + 1.))

      HFH41 = (8.*( - Z**2 + Z*XG - Z*HFMMI2 + HFMMI2 + HFMPL2)
     . )/(Z**2*(Z - 1.))


      HFH11 = (4.*(2.*Z**4-4.*Z**3+2.*Z**2*HFMPL2*XG-2.*Z**2*HFMPL2+
     . 2.*Z**2*XG**2-2.*Z**2*XG+3.*Z**2+2.*Z*HFMMI2*HFMPL2+2.*Z*
     . HFMMI2*XG-2.*Z*HFMPL2*XG+2.*Z*HFMPL2-2.*Z*XG**2+2.*Z*XG-Z
     . -HFMMI2*HFMPL2-HFMMI2*XG-HFMPL2**2-HFMPL2*XG))/(Z**2*(Z**
     . 2-2.*Z+1.))

      HFH12 = (16.*(Z*HFMMI2-Z*XG-HFMMI2-HFMPL2))/(Z**2*(Z-1.))

      HFH14 = (16.*(-2.*Z**2*XG-2.*Z*HFMMI2+2.*Z*XG+HFMMI2+HFMPL2))/(
     . Z**2*(Z**2-2.*Z+1.))

      HFH16 = (32.*(-Z*HFMMI2+Z*XG+HFMMI2+HFMPL2))/(Z**2*(Z-1.))

      HFH21 = (8.*HFM0*(-2.*Z**2*XG+2.*Z**2-2.*Z*HFMMI2+2.*Z*XG-2.*Z+
     . HFMMI2+HFMPL2))/(Z**2*(Z**2-2.*Z+1.))

      HFH22 = (32.*HFM0)/(Z*(Z-1.))


      HFG11 = -2.D0*HFH11 + HFFFF*HFH14
      HFG12 = 2.D0*XG*HFFFF*HFH14 + HFH12 + HFGGG*( HFH16
     &                                               + HFGGG*HFH14 )
      HFG1A = DSQRT(XG*HFFFF)*( HFH16 + 2.D0*HFGGG*HFH14 )
      HFG1B = HFFFF*HFH14

      HFG21 = - 2.D0*HFH21
      HFG22 = HFH22

      HFG3 = HFH41 - HFGGG*HFH43
      HFGC = DSQRT(XG*HFFFF)*( -2.D0*XG*HFH43 )

C      g_{11} * HFSG01 + g_{12} * HFSG02 - g_{44} * HFSG03
C        + cos(PHI) *( g_{11} * HFSG11 - g_{44} * HFSG13
C                 + cos(2*PHI) * g_{11} * HFSG21

      HFSG01 = XG*Y**2*HFG11 + (1.D0-Y)*HFG12
      HFSG02 = XG*Y**2*HFG21 + (1.D0-Y)*HFG22
      HFSG03 = XG*Y*(2.D0-Y)*HFG3

      HFSG11 = (2.D0-Y)*DSQRT(1.D0-Y)*HFG1A
      HFSG13 = 2.D0*Y*DSQRT(1.D0-Y)*HFGC

      HFSG21 = 2.D0*XG*(1.D0-Y)*HFG1B

      HFPROP = PROP(Q2)
      HFPRPW = PROPW(Q2)
      PROPQ1 = PROP1(Q2)
      PROPQ2 = PROP2(Q2)
C  check if up- or down-like quark:
      IF (IFLAVU.EQ.4 .OR. IFLAVU.EQ.6) THEN
C  full NC case
       IF (LSTHFL(4).EQ.4) THEN
         XG11 = UCPLGG + UCPLGZ*HFPROP + UCP1ZZ*HFPROP**2
         XG12 = UCPLGG + UCPLGZ*HFPROP + UCP2ZZ*HFPROP**2
         XG44 =          UCP4GZ*HFPROP + UCP4ZZ*HFPROP**2
       ELSEIF (LSTHFL(4).EQ.1) THEN
         XG11 = UCPLGG
         XG12 = UCPLGG
         XG44 = 0.D0
       ELSEIF (LSTHFL(4).EQ.3) THEN
         XG11 =                          UCP1ZZ*PROPQ1**2
         XG12 =                          UCP2ZZ*PROPQ1**2
         XG44 =                          UCP4ZZ*PROPQ1**2
       ELSEIF (LSTHFL(4).EQ.5) THEN
C        XG11 =        UCPLGZ*PROPQ1/Q2
C        XG12 =        UCPLGZ*PROPQ1/Q2
C        XG44 =        UCP4GZ*PROPQ1/Q2
         XG11 =        UCPLGZ*HFPROP
         XG12 =        UCPLGZ*HFPROP
         XG44 =        UCP4GZ*HFPROP
       ELSE
         XG11 = CCPL11 * PROPQ2**2
         XG12 = 0.D0
         XG44 = CCPL44 * PROPQ2**2
       ENDIF
C  down-like
      ELSE
C  full NC case
       IF (LSTHFL(4).EQ.4) THEN
         XG11 = DCPLGG + DCPLGZ*HFPROP + DCP1ZZ*HFPROP**2
         XG12 = DCPLGG + DCPLGZ*HFPROP + DCP2ZZ*HFPROP**2
         XG44 =          DCP4GZ*HFPROP + DCP4ZZ*HFPROP**2
       ELSEIF (LSTHFL(4).EQ.1) THEN
         XG11 = DCPLGG
         XG12 = DCPLGG
         XG44 = 0.D0
       ELSEIF (LSTHFL(4).EQ.3) THEN
         XG11 =                             DCP1ZZ*PROPQ1**2
         XG12 =                             DCP2ZZ*PROPQ1**2
         XG44 =                             DCP4ZZ*PROPQ1**2
       ELSEIF (LSTHFL(4).EQ.5) THEN
C        XG11 =          DCPLGZ*PROPQ1/Q2
C        XG12 =          DCPLGZ*PROPQ1/Q2
C        XG44 =          DCP4GZ*PROPQ1/Q2
         XG11 =          DCPLGZ*HFPROP
         XG12 =          DCPLGZ*HFPROP
         XG44 =          DCP4GZ*HFPROP
       ELSE
         XG11 = CCPL11 * PROPQ2**2
         XG12 = 0.D0
         XG44 = CCPL44 * PROPQ2**2
       ENDIF
      ENDIF


C  function definitions. NOTE: SIGN CORRECTED!
      HFSG(0) = XG11*HFSG01 + XG12*HFSG02 + XG44*HFSG03
      HFSG(1) = XG11*HFSG11 + XG44*HFSG13
      HFSG(2) = XG11*HFSG21

C  gluon distribution
      RETA=SNGL(ETA)
      RSHAT=SNGL(SHAT)
      CALL LYSTFU(2212,RETA,RSHAT,XPQ)
      XGETA = DBLE(XPQ(0))/ETA
C     XGETA = (1.D0 - ETA)**5/ETA

C
      DO 95 I=0,2
        HFSG(I) = HFSG(I) * XGETA * ULALPS(SNGL(SHAT)) * PARL(16)**2
     &          / ( 16.D0         )* 0.389D+9
  95  CONTINUE

C  Note the inclusion of the factor Y*Q2**2 in the weight WT.
CJR  Factor Y*Q2**2 for HFVCT1 but Y for HFVCT2 !

 1005 FORMAT(3X,'Y > 1',E12.3)
 1006 FORMAT(3X,'XG< 0',E12.3)
 1007 FORMAT(3X,'F < 0',E12.3)
 1008 FORMAT(3X,'Z < 0',E12.3)
 1009 FORMAT(3X,'Z > 1',E12.3)


      RETURN
      END

C**************************************************************************

      SUBROUTINE HFVCT1(X,IFLAV,DY,DQ2,DETA,DZ,IFAIL,WT)
C                                                                         C
C  makes the transformation between X(4) and Y,Q2,ETA,Z                   C
C  for pure photon exchange or full NC case, i.e.                         C
C  generates according to                                                 C
C  ************      dy/y**2 dQ2/Q2 dEta/Eta dz/(z*(1-z))  ****************
CJR changed to dy/y dQ2/Q2 dEta/Eta dz(z*(1-z))  to increase efficiency CJR
C  returns with IFAIL <> 0 in case of error due to numerical              C
C  uncertainties. Then set function to zero or reject, respectively.      C
C  RT is the weight for the transformation.                               C
C                                                                         C

C--        Calls to: -

C--        Called by: HFVECT

C--        Functions used:


C  input variables
      REAL*8 X(4)
      INTEGER IFLAV
C  output variables
      REAL*8 DY,DQ2,DETA,DZ,WT
      INTEGER IFAIL
C  internal use variables
      REAL*8 QMSSMI,DW2MIN,DL2MIN,HFS,WUR,YNCMIN,YNCMAX,DQ2MIN,DQ2MAX,
     &ETAMIN,ETAMAX,DZMIN,DZMAX,SHAT,XGAM2,DDQ2,DDY,DDETA,DETAMN
C  Common blocks of LUND
      COMMON/LUDAT2/KCHG(500,3),PMAS(500,4),PARF(2000),VCKM(4,4)
C  Common blocks of LEPTO
      COMMON /LEPTOU/ CUT(14),LST(40),PARL(30),AAX,AAY,AAW2,AAQ2,AAU
C--      AROMA common
      COMMON /HFDATA/ PARHFL(10),CUTHFL(8),LSTHFL(10)
      REAL*8 PARHFL,CUTHFL
      INTEGER LSTHFL
CJR-     added common block for masses in double precision
      REAL*8 DHFS,DMASE,DMASP,DMAS
      COMMON /HFJRDM/ DHFS,DMASE,DMASP,DMAS(6)
      DATA NEV,NPR/0,0/
      SAVE NEV

      NEV=NEV+1
C
      IFAIL = 1
      DY = 0.D0
      DQ2 = 0.D0
      DETA = 0.D0
      DZ = 0.D0
      WT = 0.D0
C
C..full NC and pure photon case extract factor Q2*Y**2*ETA
C  quark mass
CJR      QMSSMI = PMAS(IFLAV,1 )
      QMSSMI = DMAS( IFLAV )
C  Define DW2MIN, DL2MIN, HFS
      DW2MIN = (QMSSMI+QMSSMI+DMASP)**2 - DMASP**2
      DL2MIN = (QMSSMI+QMSSMI)**2
      DL2MIN = DL2MIN+4.D0*PARHFL(4)
      DW2MIN = MAX(DW2MIN,DL2MIN)
CJR      HFS=PARL(21)
      HFS = DHFS
C  Calculate y-cuts
      WUR = 1.D0 - 4.D0*DMASE**2*DW2MIN/(HFS-DW2MIN)**2
C  Reject if out of bounds
      IF (WUR .LE. 0.D0) THEN
         IFAIL = 3
CJR         WRITE(6,1003) WUR
         RETURN
      ENDIF
      WUR = (HFS-DW2MIN)*SQRT(WUR)
CJR      YNCMIN = (HFS+DW2MIN-WUR)/(2.D0*(HFS+DMASE**2))
      YNCMAX = (HFS+DW2MIN+WUR)/(2.D0*(HFS+DMASE**2))
      YNCMIN = DW2MIN/YNCMAX/(HFS+DMASE**2)
C  Calculate the effective Y-cuts:
      YNCMIN = MAX(YNCMIN,CUTHFL(1))
      YNCMAX = MIN(YNCMAX,CUTHFL(2))
C...Return if no phase space from mixed y-cuts.
      IF(YNCMIN.GT.YNCMAX) THEN
CJR       WRITE(6,*) ' Warning from HFVCT1: YMIN, YMAX = ',
CJR     &  YNCMIN,YNCMAX
        RETURN
      ENDIF
C  Calculate Y

CJR         DDY = YNCMIN / ( 1.D0 - X(2) + YNCMIN*X(2)/YNCMAX )
C         IF (X(2).GT.0.5D0) THEN
C            DDY = YNCMAX / ( X(2) + (1.D0-X(2))*YNCMAX/YNCMIN )
C         ELSE
C            DDY = YNCMIN / ( 1.D0 - (1.D0-YNCMIN/YNCMAX)*X(2) )
C         ENDIF
         DDY = YNCMIN*(YNCMAX/YNCMIN)**X(2)
         DY = DDY
      IF (DY.LT.0.D0 .OR. DY.GT.1.D0) THEN
         IFAIL = 6
CJR         WRITE(6,1006) DY
         RETURN
      ENDIF
C  Calculate Q**2 cuts
         DQ2MIN = DMASE**2*DY**2/(1.D0-DY)
         DQ2MAX = DY*HFS-DW2MIN
C  Reject if out of bounds
         IF(DQ2MAX.LT.DQ2MIN)  THEN
CJR           WRITE(6,1002) DQ2MIN,DQ2MAX
           IFAIL = 2
           RETURN
         ENDIF
C  Calculate the effective Q**2 cuts
         DQ2MIN = MAX(DQ2MIN,CUTHFL(3))
         DQ2MAX = MIN(DQ2MAX,CUTHFL(4))
C...Return if no phase space from mixed y-cuts.
      IF(DQ2MIN.GT.DQ2MAX) THEN
CJR        WRITE(6,*) 'HFVCT1, No phase space after cuts: DQ2MIN, DQ2MAX ='
CJR     &              ,DQ2MIN,DQ2MAX
        RETURN
      ENDIF
C  Define Q**2
         DDQ2 = DQ2MIN * (DQ2MAX/DQ2MIN)**X(1)
CJR         DDQ2 = DQ2MAX*DQ2MIN/(DQ2MAX-X(1)*(DQ2MAX-DQ2MIN))
         DQ2 = DDQ2
C  Define ETA
         DETAMN = (DDQ2 + DL2MIN)/(DY*HFS)
         ETAMIN = DETAMN
CJR--         take hard cuts into account
         ETAMIN=MAX(ETAMIN,CUTHFL(5))
         ETAMAX=MIN(1.D0,CUTHFL(6))
C  check phase space for eta
         IF (ETAMIN .GT. ETAMAX) RETURN
         DDETA = ETAMIN*(ETAMAX/ETAMIN)**X(3)
CJR         DDETA = DETAMN/(1.D0-X(3)*(1.D0-DETAMN))
         DETA = DDETA
      IF (DETA.LT.0.D0 .OR. DETA.GT.1.D0) THEN
         IFAIL = 5
CJR         WRITE(6,1005) DETA
         RETURN
      ENDIF
C..
         SHAT = DDETA*DDY*HFS - DDQ2
C..Takes care of numerical uncertanties.
C..to guarentee that lam in 'DIFSIG' is non-negativ..
         IF (SHAT .LT. DL2MIN) THEN
            IFAIL = 1
CJR            WRITE(6,1001) SHAT,SHAT-DL2MIN
            RETURN
         ENDIF
C  Define Z
         XGAM2 = SQRT(1.D0-DL2MIN/SHAT)
CJR         DZMIN = (1.D0-XGAM2)/2.D0
         DZMAX = (1.D0+XGAM2)/2.D0
         DZMIN = DL2MIN/4.D0/SHAT/DZMAX

         DZMIN=MAX(DZMIN,CUTHFL(7))
         DZMAX=MIN(DZMAX,CUTHFL(8))
         IF (DZMAX.LT.DZMIN) RETURN

C1         DZ = DZMIN + X(4) * (DZMAX - DZMIN)
         DZ = DZMIN/(1.D0-DZMIN) *
     &      (  DZMAX/(1.D0-DZMAX)*(1.D0-DZMIN)/DZMIN  )**X(4)
         DZ = DZ / ( 1.D0 + DZ )

C
C  Reject if out of bounds
      IF (DZ.LT.0.D0 .OR. DZ.GT.1.D0) THEN
         IFAIL = 4
CJR         WRITE(6,1004) DZ
         RETURN
      ENDIF
C
C  calculate the weight
C
         WT = DETA / DQ2 *
     &     DZ*(1.D0-DZ)*LOG(DZMAX/(1.D0-DZMAX)*(1.D0-DZMIN)/DZMIN) *
C1     &     (DZMAX-DZMIN)*
C     &     (1.D0/DQ2MIN-1.D0/DQ2MAX)*
     &     LOG(DQ2MAX/DQ2MIN)*
C     &     (1.D0/YNCMIN-1.D0/YNCMAX)*
     &     LOG(YNCMAX/YNCMIN)*
CJR     &     (1.D0/DETAMN-1.D0)
     &     (LOG(ETAMAX/ETAMIN))
         IFAIL=0
C
 1001 FORMAT(2X,'numerical uncertainty in HFVCT1 for SHAT (<0) ',
     & 2E15.3,/)
 1002 FORMAT(2X,'numerical uncertainty in HFVCT1 for Q**2 ',2E15.3,/)
 1003 FORMAT(2X,'numerical uncertainty in HFVCT1 for Y (<0) ',
     & E15.3,/)
 1004 FORMAT(2X,'numerical uncertainty in HFVCT1 for Z (<0 or >1) ',
     & E15.3,/)
 1005 FORMAT(2X,'numerical uncertainty in HFVCT1 for ETA (<0 or >1) ',
     & E15.3,/)
 1006 FORMAT(2X,'numerical uncertainty in HFVCT1 for Y (<0 or >1) ',
     & E15.3,/)
      RETURN
      END

C***********************************************************************

      SUBROUTINE HFVCT2(X,IFLAVU,IFLAVD,DY,DQ2,DETA,DZ,IFAIL,WT)
C                                                                      C
C  makes the transformation between X(4) and Y,Q2,ETA,Z                C
C  for pure Z, pure W exchange (and g-Z interference), i.e.            C
C  generates according to                                              C
C  **********      dy/y dQ2/Q2 dEta dz/(z*(1-z))   *********************
CJR changed to  dy/y dQ2 dEta/Eta dz/(z*(1-z))  to increase efficiency CJR
C  returns with IFAIL <> 0 in case of error due to numerical           C
C  uncertainties. Then set function to zero or reject, respectively.   C
C  RT is the weight for the transformation.                            C
C  IFLAVU = flavour of up-like quark,                                  C
C                             IFLAVD = flavour of down-like quark      C
C                                                                      C

C--        Calls to: -

C--        Called by: HFVECT

C--        Functions used:


C  input variables
      REAL*8 X(4)
      INTEGER IFLAVU,IFLAVD
C  output variables
      REAL*8 DY,DQ2,DETA,DZ,WT
      INTEGER IFAIL
C  internal use variables
      REAL*8 QMSSMU,DW2MIN,DL2MIN,HFS,WUR,YNCMIN,YNCMAX,DQ2MIN,DQ2MAX,
     &       ETAMIN,ETAMAX,DZMIN,DZMAX,SHAT,XGAM2,XLAM,QMSSMD
     &      , DDQ2, DDY, DDETA, DETAMN, CETA
C  Common blocks of LUND
      COMMON/LUDAT2/KCHG(500,3),PMAS(500,4),PARF(2000),VCKM(4,4)
C  Common blocks of LEPTO
      COMMON /LEPTOU/ CUT(14),LST(40),PARL(30),AAX,AAY,AAW2,AAQ2,AAU
CJR--    AROMA common
      COMMON /HFDATA/ PARHFL(10),CUTHFL(8),LSTHFL(10)
      REAL*8 PARHFL,CUTHFL
      INTEGER LSTHFL
CJR-     added common block for masses in double precision
      REAL*8 DHFS,DMASE,DMASP,DMAS
      COMMON /HFJRDM/ DHFS,DMASE,DMASP,DMAS(6)
      DATA NEV,NPR/0,0/,PT2MIN/0.01/


      NEV=NEV+1
C
      IFAIL = 1
      DY = 0.D0
      DQ2 = 0.D0
      DETA = 0.D0
      DZ = 0.D0
      WT = 0.D0
C
C..extract factor Y
C  quark masses
C  for e(-) scattering m_f = m(down-like quark)
C                      m_f' = m(up-like antiquark)
C  whereas for e(+) scattering m_f = m(up-like quark)
C                      m_f' = m(down-like antiquark)
C  Set first for e(-) scattering
C  thus QMSSMD=m_f,  QMSSMU=m_f'
CJR      QMSSMD = PMAS(IFLAVD,1 )
      QMSSMD = DMAS( IFLAVD )
CJR      QMSSMU = PMAS(IFLAVU,1 )
      QMSSMU = DMAS( IFLAVU )
C  Change for e(+)
      IF (LSTHFL(5).GT.0) THEN
        QMASS = QMSSMD
        QMSSMD = QMSSMU
        QMSSMU = QMASS
      ENDIF
C
C  Define DW2MIN, DL2MIN, HFS
      DW2MIN = (QMSSMU+QMSSMD+DMASP)**2 - DMASP**2
      DL2MIN = (QMSSMU+QMSSMD)**2
      CETA=0.D0
      IF(PARHFL(4).GT.PT2MIN)
     &CETA=PARHFL(4)+QMSSMD*QMSSMU*(-1.D0+SQRT(1.D0+PARHFL(4)*
     &(PARHFL(4)+QMSSMD**2+QMSSMU**2)/(QMSSMD**2*QMSSMU**2)))
      DL2MIN=DL2MIN+2.D0*CETA
      DW2MIN=MAX(DW2MIN,DL2MIN)
CJR      HFS=PARL(21)
      HFS = DHFS
C  Calculate y-cuts
      WUR = 1.D0 - 4.D0*DMASE**2*DW2MIN/(HFS-DW2MIN)**2
C  Reject if out of bounds
      IF (WUR .LE. 0.D0) THEN
         IFAIL = 3
CJR         WRITE(6,1003) WUR
         RETURN
      ENDIF
      WUR = (HFS-DW2MIN)*SQRT(WUR)
CJR      YNCMIN = (HFS+DW2MIN-WUR)/(2.D0*(HFS+DMASE**2))
      YNCMAX = (HFS+DW2MIN+WUR)/(2.D0*(HFS+DMASE**2))
      YNCMIN = DW2MIN/YNCMAX/(HFS+DMASE**2)
C     YNCMIN = DW2MIN/HFS + DMASE**2*DW2MIN/(HFS*(HFS-DW2MIN))
C     YNCMAX = 1.D0      - DMASE**2*DW2MIN/(HFS*(HFS-DW2MIN))
C  Calculate the effective Y-cuts:
      YNCMIN = MAX(YNCMIN,CUTHFL(1))
      YNCMAX = MIN(YNCMAX,CUTHFL(2))
C...Return if no phase space from mixed y-cuts.
      IF(YNCMIN.GT.YNCMAX) THEN
C       WRITE(6,*) ' Warning from HFVCT2: YNCMIN, YNCMAX = ',
C    &  YNCMIN,YNCMAX
        RETURN
      ENDIF
C  Calculate Y
        DDY = YNCMIN * (YNCMAX/YNCMIN)**(1.D0-X(2))
Cflat        DDY = YNCMIN+(YNCMAX-YNCMIN)*X(2)
C1/y^2        DDY = YNCMIN / ( 1.D0 - X(2) + YNCMIN*X(2)/YNCMAX )
        DY = DDY
C  Calculate Q**2 cuts
         DQ2MIN = DMASE**2*DY**2/(1.D0-DY)
         DQ2MAX = DY*HFS-DW2MIN
C  Reject if out of bounds
         IF (  DQ2MAX .LT. DQ2MIN  )  THEN
CJR           WRITE(6,1002) DQ2MIN,DQ2MAX
           IFAIL = 2
           RETURN
         ENDIF
C  Calculate the effective Q**2 cuts
         DQ2MIN = MAX(DQ2MIN,CUTHFL(3))
         DQ2MAX = MIN(DQ2MAX,CUTHFL(4))
C...Return if no phase space from mixed y-cuts.
      IF(DQ2MIN.GT.DQ2MAX) THEN
CJR        WRITE(6,*) 'HFVCT2, No phase space after cuts: DQ2MIN, DQ2MAX ='
CJR     &              ,DQ2MIN,DQ2MAX
        RETURN
      ENDIF
C  Define Q**2
         DDQ2 = DQ2MIN + (DQ2MAX-DQ2MIN)*X(1)
CJR        DDQ2 = DQ2MIN * (DQ2MAX/DQ2MIN)**X(1)
         DQ2 = DDQ2
C  Define ETA
         DETAMN = (DDQ2 + DL2MIN)/(DY*HFS)
         ETAMIN = DETAMN
CJR--         take hard cuts into account
         ETAMIN=MAX(ETAMIN,CUTHFL(5))
         ETAMAX=MIN(1.D0,CUTHFL(6))
C  check phase space for ETA
         IF (ETAMIN .GT. ETAMAX) RETURN
         DDETA = ETAMIN*(ETAMAX/ETAMIN)**X(3)
CJR         DDETA = DETAMN + X(3) * (1.D0 - DETAMN)
         DETA = DDETA
C..
         SHAT = DDETA*DDY*HFS - DDQ2
C..Takes care of numerical uncertanties.
C..to guarentee that lam in 'DIFSIG' is non-negativ..
         IF (SHAT .LT. DL2MIN) THEN
            IFAIL = 1
CJR            WRITE(6,1001) SHAT
            RETURN
         ENDIF
C  Define Z
         XGAM2 = SHAT + QMSSMD**2 - QMSSMU**2
         XLAM = (SHAT - QMSSMU**2 - QMSSMD**2)**2
     &                 - 4.D0 * QMSSMU**2 * QMSSMD**2
         IF(PARHFL(4).GT.PT2MIN) XLAM = XLAM - 4.D0*SHAT*PARHFL(4)
         DZMIN = (XGAM2-SQRT(XLAM))/(2.D0*SHAT)
         DZMAX = (XGAM2+SQRT(XLAM))/(2.D0*SHAT)

         DZMIN=MAX(DZMIN,CUTHFL(7))
         DZMAX=MIN(DZMAX,CUTHFL(8))
         IF (DZMAX.LT.DZMIN) RETURN

C        DZ = DZMIN + X(4) * (DZMAX - DZMIN)
C
         DZ = DZMIN/(1.D0-DZMIN) *
     &      (  DZMAX/(1.D0-DZMAX)*(1.D0-DZMIN)/DZMIN  )**X(4)
         DZ = DZ / ( 1.D0 + DZ )
C
C  Reject if out of bounds
      IF (DZ.LT.0.D0 .OR. DZ.GT.1.D0) THEN
         IFAIL = 4
CJR         WRITE(6,1004) DZ
         RETURN
      ENDIF
C
C  calculate the weight
C
         WT = DETA/DY*
     &     DZ*(1.D0-DZ)*LOG(DZMAX/(1.D0-DZMAX)*(1.D0-DZMIN)/DZMIN) *
C     &     (DZMAX-DZMIN)*
C     &     LOG(DQ2MAX/DQ2MIN)
     &     (DQ2MAX-DQ2MIN)*
Cflat     &     (YNCMAX-YNCMIN)*
     &     LOG(YNCMAX/YNCMIN)*
C1/y^2    &     (1.D0/YNCMIN-1.D0/YNCMAX)*
C     &     (ETAMAX - ETAMIN)*
     &     (LOG(ETAMAX/ETAMIN))
C
      IFAIL = 0
C
 1001 FORMAT(2X,'numerical uncertainty in HFVCT2 for SHAT (<0) ',
     & E15.3,/)
 1002 FORMAT(2X,'numerical uncertainty in HFVCT2 for Q**2 ',2E15.3,/)
 1003 FORMAT(2X,'numerical uncertainty in HFVCT2 for Y (<0) ',
     & E15.3,/)
 1004 FORMAT(2X,'numerical uncertainty in HFVCT2 for Z (<0 or >1) ',
     & E15.3,/)
      RETURN
      END

C **********************************************************************

      SUBROUTINE HFMEPS

      COMMON /LEPTOU/ CUT(14),LST(40),PARL(30),X,Y,W2,Q2,U
      COMMON/LUJETS/N,K(4000,5),P(4000,5),V(4000,5)
      COMMON/LUDAT1/MSTU(200),PARU(200),MSTJ(200),PARJ(200)
      COMMON /LBOOST/ DBETA(2,3),STHETA(2),SPHI(2),PB(5),PHIR
      COMMON /LYPARA/ IPY(80),PYPAR(80),PYVAR(80)
      COMMON /LYPROC/ ISUB,KFL(3,2),XPY(2),SH,TH,UH,Q2PY,XSEC(0:40)
      COMMON /LYINT1/ XQPY(2,-6:6),DSIG(-6:6,-6:6,5),FSIG(10,10,3)
      DOUBLE PRECISION DBETA
      DOUBLE PRECISION DPQ2,DROBO(5)
      DOUBLE PRECISION DELTAP(4),DPLONG,DBTOT,DGAMMA,DROOT
      DIMENSION KS(9,5),PS(9,5),ROBO(5),XPQ(-6:6)
      SAVE KS,PS

C     CALL GULIST(100,2)
C...Save event record in hadronic cms
      DO 10 I=1,7
      DO 10 J=1,5
      KS(I,J)=K(I,J)
   10 PS(I,J)=P(I,J)
C...Rearrange event record to PYSSPA standard
      IP2=6
      IF(LST(24).EQ.3) IP2=7
      DO 20 J=1,5
      K(3,J)=0.
      P(3,J)=0.
      K(4,J)=0
      P(4,J)=0.
      K(5,J)=KS(3,J)
      P(5,J)=PS(3,J)
      K(7,J)=KS(4,J)
      P(7,J)=PS(4,J)
      K(8,J)=KS(5,J)
      P(8,J)=PS(5,J)
      K(9,J)=KS(4,J)
      P(9,J)=PS(4,J)
      K(10,J)=KS(IP2,J)
   20 P(10,J)=PS(IP2,J)
      K(5,3)=3
      K(6,3)=4
      K(7,3)=5
      K(8,3)=6
      K(9,3)=5
      K(10,3)=6
      DO 30 I=5,10
   30 K(I,1)=21
      K(9,1)=0
C...Incoming parton = outgoing 2 parton - boson fourvectors
      DO 40 J=1,4
   40 P(6,J)=P(8,J)+P(10,J)-P(5,J)
      P(6,5)=0.
      K(6,2)=LST(25)
      IF(LST(24).EQ.3) K(6,2)=21
      N=10
C     CALL GULIST(101,2)

      XR=X
      DPQ2=DBLE(Q2)
C...Partons with colour information in hadronic cms frame.
      DO 120 I=11,27
      DO 120 J=1,5
      K(I,J)=0
      P(I,J)=0.
  120 V(I,J)=0.
      NS=20
      DO 130 J=1,5
      K(NS+1,J)=K(5,J)
      P(NS+1,J)=P(5,J)
      K(NS+3,J)=K(6,J)
      P(NS+3,J)=P(6,J)
      K(NS+5,J)=K(8,J)
      P(NS+5,J)=P(8,J)
      K(NS+6,J)=K(10,J)
  130 P(NS+6,J)=P(10,J)
C...Old standard continuation lines
      K(NS+2,1)=-1
      K(NS+2,3)=NS+1
      K(NS+4,1)=-1
      K(NS+4,3)=NS+3
      P(NS+4,3)=27
      P(NS+4,4)=27
C...Origin and colour info for incoming parton
      K(NS+3,1)=13
      K(NS+3,3)=2
      K(NS+3,4)=27
      K(NS+3,5)=27
C...Colour info for two outgoing partons
      K(NS+5,1)=3
      K(NS+6,1)=3
      IF(K(NS+6,2).EQ.21) THEN
C...qg-event
        IF(K(NS+5,2).GT.0) THEN
          K(NS+5,4)=(NS+6)*MSTU(5)
          K(NS+5,5)=(NS+7)*MSTU(5)
          K(NS+6,4)=(NS+7)*MSTU(5)
          K(NS+6,5)=(NS+5)*MSTU(5)
        ELSE
          K(NS+5,4)=(NS+7)*MSTU(5)
          K(NS+5,5)=(NS+6)*MSTU(5)
          K(NS+6,4)=(NS+5)*MSTU(5)
          K(NS+6,5)=(NS+7)*MSTU(5)
        ENDIF
      ELSE
C...qqbar-event
        K(NS+5,4)=(NS+7)*MSTU(5)
        K(NS+5,5)=(NS+7)*MSTU(5)
        K(NS+6,4)=(NS+7)*MSTU(5)
        K(NS+6,5)=(NS+7)*MSTU(5)
      ENDIF
C...Effective outgoing parton = sum of both outgoing partons
      K(NS+7,1)=14
      K(NS+7,3)=3
      IF(LST(24).EQ.2) THEN
        K(NS+7,2)=K(NS+5,2)
        IF(K(NS+7,2).EQ.21) WRITE(6,*) ' Warning: K(NS+7,2)=',K(NS+7,2)
        IF(K(NS+7,2).GT.0) THEN
          K(NS+7,4)=(NS+3)*MSTU(5)+26
          K(NS+7,5)=(NS+3)*MSTU(5)+25
        ELSE
          K(NS+7,4)=(NS+3)*MSTU(5)+25
          K(NS+7,5)=(NS+3)*MSTU(5)+26
        ENDIF
      ELSE
        K(NS+7,2)=21
        IF(K(NS+5,2).GT.0) THEN
          K(NS+7,4)=(NS+3)*MSTU(5)+25
          K(NS+7,5)=(NS+3)*MSTU(5)+26
        ELSE
          K(NS+7,4)=(NS+3)*MSTU(5)+26
          K(NS+7,5)=(NS+3)*MSTU(5)+25
        ENDIF
      ENDIF
      DO 140 J=1,4
  140 P(NS+7,J)=P(8,J)+P(10,J)

      IT=NS+7
      IF(ABS(P(IT,1)).GT.0.1.OR.ABS(P(IT,2)).GT.0.1) THEN
C      WRITE(6,*) 'Warning: non-zero pt on final shower initiator'
C      WRITE(6,*)'1:',IT,K(IT,2),P(IT,1),P(IT,2),P(IT,3),P(IT,4),P(IT,5)
C      WRITE(6,*)'1:',8 ,K( 8,2),P( 8,1),P( 8,2),P( 8,3),P( 8,4),P( 8,5)
C       WRITE(6,*)'1:',10,K(10,2),P(10,1),P(10,2),P(10,3),P(10,4),P(10,5)
        LST(21)=906
        RETURN
      ENDIF
      P(IT,1)=0.
      P(IT,2)=0.

      P(NS+7,5)=SQRT(MAX(0.,P(NS+7,4)**2-P(NS+7,1)**2-P(NS+7,2)**2-
     &P(NS+7,3)**2))
      N=NS+7
C     CALL GULIST(103,2)

C...Scale for bremsstrahlung etc.
      Q2PY=Q2
      IPY(40)=10
      IPY(47)=N
C...Save quantities for later use.
      XPY(1)=1.
      XPY(2)=XR
      CALL LYSTFU(K(2,2),XR,Q2,XPQ)
      DO 160 IFL=-6,6
  160 XQPY(2,IFL)=XPQ(IFL)
      IF(LST(23).EQ.1) THEN
        ISUB=39
        IPY(11)=1
      ELSEIF(LST(23).EQ.3) THEN
        ISUB=39
        IPY(11)=2
      ELSEIF(LST(23).EQ.4) THEN
        ISUB=39
        IPY(11)=3
      ELSEIF(LST(23).EQ.2) THEN
        ISUB=40
      ENDIF
      KFL(2,1)=K(5,2)
      KFL(2,2)=K(6,2)
      KFL(1,1)=KFL(2,1)
      KFL(1,2)=KFL(2,2)
      IF(ISUB.EQ.39) KFL(3,1)=K(1,2)
      IF(ISUB.EQ.40) KFL(3,1)=K(1,2)+ISIGN(1,K(1,2))
      KFL(3,2)=K(27,2)
      PYVAR(2)=PARL(21)
      PYVAR(1)=SQRT(PYVAR(2))
      PYVAR(3)=P(1,5)
      PYVAR(4)=P(2,5)
      PYVAR(5)=PYVAR(1)/2.
      IPY(41)=K(1,2)
      IPY(42)=K(2,2)
      IPY(48)=0

C...Generate timelike parton shower (if required)
      IF(IPY(13).EQ.1) THEN
        CALL HFSCAL(1,QMAX)
        CALL LUSHOW(25,26,QMAX)
      ENDIF
      IT=25
      IF(N.GE.27) IT=27
      NS=N
C     CALL GULIST(104,2)

C...Generate spacelike parton shower (if required)
      IPU1=0
      IPU2=23
      IF(XPY(2)*(1.+(P(IT,5)**2+PYPAR(22))/P(21,5)**2).GT.0.999) THEN
        LST(21)=907
        RETURN
      ENDIF
      IF(IPY(14).GE.1) THEN
        CALL HFSSPA(IPU1,IPU2)
        IF(LST(21).NE.0) RETURN
      ELSE
        DO 220 I=NS+1,NS+4
        DO 220 J=1,5
        K(I,J)=0
        P(I,J)=0.
  220   V(I,J)=0.
        K(NS+1,1)=11
        K(NS+1,2)=KFL(2,1)
        K(NS+1,3)=21
        DO 230 J=1,5
  230   P(NS+1,J)=P(21,J)
        K(NS+2,1)=-1
        K(NS+2,3)=NS+1
        K(NS+3,1)=13
        K(NS+3,2)=KFL(2,2)
        K(NS+3,3)=23
        K(NS+3,4)=23
        K(NS+3,5)=23
CRJ this is not good for small Q^2!
CJR        P(NS+3,3)=(P(IT,5)**2+Q2)*(P(21,4)-P(21,3))/(2.*Q2)
CJR        P(NS+3,4)=-P(NS+3,3)
        P(NS+3,4)=(P(IT,5)**2+Q2)/(P(21,4)+P(21,3))/2.
        P(NS+3,3)=-P(NS+3,4)
        K(NS+4,1)=-1
        K(NS+4,3)=NS+3
        P(NS+4,3)=23
        P(NS+4,4)=23
        P(24,1)=NS+3
        P(24,2)=NS+3
        K(23,4)=K(23,4)+(NS+3)*MSTU(5)
        K(23,5)=K(23,5)+(NS+3)*MSTU(5)
        IPU1=0
        IPU2=NS+3
        N=N+4
      ENDIF
C     CALL GULIST(105,2)

C...Rotate and boost outgoing parton shower
      IF(N.GT.31) THEN
        K(N+1,1)=0
        DO 210 J=1,4
  210   P(N+1,J)=P(NS+1,J)+P(NS+3,J)
        IF(P(N+1,4).LE.1.01*P(IT,5)) THEN
          LST(21)=908
          RETURN
        ENDIF
        ROBO(1)=ULANGL(P(IT,3),SQRT(P(IT,1)**2+P(IT,2)**2))
        ROBO(2)=ULANGL(P(IT,1),P(IT,2))
      IF(ABS(ROBO(1)).GT.0.001.OR.ABS(ROBO(2)).GT.0.001) THEN
      WRITE(6,*) '1:',IT,K(IT,2),P(IT,1),P(IT,2),P(IT,3),P(IT,4),P(IT,5)
      WRITE(6,*) '   ROBO(1-2)=',ROBO(1),ROBO(2)
      ENDIF
        CALL LUDBRB(25,NS,0.,-ROBO(2),0.D0,0.D0,0.D0)
        CALL LUDBRB(25,NS,-ROBO(1),0.,0.D0,0.D0,0.D0)
C...Replace old rotation method with x,y,z-boost to preserve QCD phi-dep
        DELTAP(1)=DBLE(P(N+1,1))
        DELTAP(2)=DBLE(P(N+1,2))
        DELTAP(3)=DBLE(P(N+1,3)) - DBLE(P(IT,3))
        DELTAP(4)=SQRT(DELTAP(1)**2+DELTAP(2)**2+DELTAP(3)**2)
        IF(DELTAP(4).LT.1.D-11) GOTO 410
        DPLONG=-(DBLE(P(IT,3))*DELTAP(3))/DELTAP(4)
        DROOT=MAX(0.D0,DBLE(P(N+1,4))**2-DBLE(P(IT,4))**2+DPLONG**2)
        DBTOT=-(DPLONG*DBLE(P(IT,4))-DBLE(P(N+1,4))*SQRT(DROOT))/
C    &  SQRT(DBLE(P(N+1,4))**2-DBLE(P(IT,4))**2+DPLONG**2))/
     &  (DPLONG**2+DBLE(P(N+1,4))**2)
        DGAMMA=1.D0/SQRT(1.D0-DBTOT**2)
        DO 400 I = 1,3
  400   DROBO(I+2)=DELTAP(I)/(DGAMMA/(DGAMMA+1.D0)*
     &  (DBLE(P(N+1,4))-DGAMMA*DBLE(P(IT,4)))+DGAMMA*DBLE(P(IT,4)))
        CALL LUDBRB(25,NS,0.,0.,DROBO(3),DROBO(4),DROBO(5))
  410   CONTINUE
C...End phi-correction
      ENDIF
C     CALL GULIST(106,2)

      Q2PY=Q2
C...Hadron remnant and primordial kt
      IPY(47)=N
      CALL LYREMN(IPU1,IPU2)
      IF(IPY(48).EQ.1) THEN
        LST(21)=909
        RETURN
      ENDIF
C     CALL GULIST(107,2)

C...Rearrange partons along strings
      MSTU(24)=0
      CALL LUPREP(0)
      IF(MSTU(24).NE.0) THEN
C       CALL GULIST(188,2)
        IF(LST(3).GE.1) WRITE(6,*) ' LUPREP error MSTU(24)= ',MSTU(24)
        LST(21)=910
        RETURN
      ENDIF
C     CALL GULIST(109,2)

C...Clean up event record -> order:
C...1=inc. lepton; 2=inc. nucleon; 3=exch boson; 4=scat. lepton;
C...5=inc. parton before initial shower; 6=inc. parton at hard scattering
C...after shower; 7,8=first,second parton from hard scattering
C...before final shower
      LST(26)=7
      DO 510 J=1,5
      K(N+1,J)=K(4,J)
  510 P(N+1,J)=P(4,J)
      DO 520 J=1,5
      K(3,J)=K(5,J)
      P(3,J)=P(5,J)
      K(4,J)=K(9,J)
      P(4,J)=P(9,J)
      K(5,J)=K(N+1,J)
      P(5,J)=P(N+1,J)
      K(6,J)=K(NS+3,J)
      P(6,J)=P(NS+3,J)
C     K(7,J)=K(IT,J)
C     P(7,J)=P(IT,J)
      K(7,J)=K(25,J)
      P(7,J)=P(25,J)
      K(8,J)=K(26,J)
      P(8,J)=P(26,J)
  520 CONTINUE
      K(3,3)=1
      K(4,3)=1
      K(6,1)=21
      K(6,3)=5
      K(6,4)=0
      K(6,5)=0
      K(7,1)=21
      K(7,3)=6
      K(7,4)=0
      K(7,5)=0
      K(8,1)=21
      K(8,3)=6
      K(8,4)=0
      K(8,5)=0
C...Activate line with scattered lepton.
      K(4,1)=1
C...Deactivate obsolete lines 9, 10, 21, NS+1 (extra lines with boson)
      K(9,1)=0
      K(10,1)=0
      K(21,1)=0
      IF(K(NS+1,2).EQ.K(3,2)) K(NS+1,1)=0
C...Zero irrelevant lines with K(I,1)<0
      DO 540 I=1,N
      IF(K(I,1).LT.0) THEN
        DO 530 J=1,5
        K(I,J)=0
  530   P(I,J)=0.
      ENDIF
  540 CONTINUE
C     CALL GULIST(110,2)
C...Delete internal parton lines, i.e. with K(I,1)=13,14
      IF(MOD(LST(4)/10,10).EQ.0) THEN
        CALL LTIMEX(T1)
        CALL LUEDIT(14)
        CALL LTIMEX(T2)
C       CALL GULIST(111,2)
      ENDIF
C...Delete empty lines
      CALL LTIMEX(T1)
      CALL LUEDIT(12)
      CALL LTIMEX(T2)
C     CALL GULIST(112,2)

      RETURN
      END

C **********************************************************************

      SUBROUTINE HFSCAL(INFIN,QMAX)

C--     input: INFIN=+/-1 for final/initial state radiation
C--     output: QMAX in GeV

C...Give maximum virtuality of partons in parton showers.

      COMMON /LEPTOU/ CUT(14),LST(40),PARL(30),X,Y,W2,Q2,U
      COMMON /LYPARA/ IPY(80),PYPAR(80),PYVAR(80)
      COMMON/LUJETS/N,K(4000,5),P(4000,5),V(4000,5)
      COMMON /HFLVAR/ SHAT,ETA,Z,PHIQQ,PT2Q,TM2Q1,TM2Q2,ZJ,IFLQ,IFLQB,
     &PHIFL(0:9,0:2),DBETAZ
      DOUBLE PRECISION DBETAZ
      COMMON /HFDATA/ PARHFL(10),CUTHFL(8),LSTHFL(10)
      REAL*8 PARHFL,CUTHFL
      INTEGER LSTHFL

      FOUR(I,J)=P(I,4)*P(J,4)-P(I,1)*P(J,1)-P(I,2)*P(J,2)-P(I,3)*P(J,3)

      QMAX=0.1
CJR--  final scale
      IF(INFIN.GT.0) THEN
          IF(LSTHFL(7).EQ.1) THEN
            QMAX=Q2
          ELSEIF(LSTHFL(7).EQ.2) THEN
            QMAX=W2
          ELSEIF(LSTHFL(7).EQ.3) THEN
            QMAX=SHAT
          ELSEIF(LSTHFL(7).EQ.4) THEN
            QMAX=(SQRT(TM2Q1)+SQRT(TM2Q2))**2
          ELSEIF(LSTHFL(7).EQ.5) THEN
            QMAX=TM2Q1+TM2Q2
          ELSE
            WRITE(6,*) ' Warning, HFSCAL: LSTHFL(7)=',
     &               LSTHFL(7),' not allowed'
            STOP
          ENDIF
          QMAX=SQRT(PYPAR(25)*QMAX)
CJR--  initial scale
      ELSEIF(INFIN.LT.0) THEN
          IF(LSTHFL(9).EQ.1) THEN
            QMAX=Q2
          ELSEIF(LSTHFL(9).EQ.2) THEN
            QMAX=W2
          ELSEIF(LSTHFL(9).EQ.3) THEN
            QMAX=SHAT
          ELSEIF(LSTHFL(9).EQ.4) THEN
            QMAX=(SQRT(TM2Q1)+SQRT(TM2Q2))**2
          ELSEIF(LSTHFL(9).EQ.5) THEN
            QMAX=TM2Q1+TM2Q2
          ELSEIF(LSTHFL(9).EQ.6) THEN
            QMAX=MAX(ABS(-Q2-2.*FOUR(25,21)),
     &               ABS(-Q2-2.*FOUR(26,21)))
          ELSE
            WRITE(6,*) ' Warning, HFSCAL: LSTHFL(9)=',
     &               LSTHFL(9),' not allowed'
            STOP
          ENDIF
          QMAX=SQRT(PYPAR(26)*QMAX)
      ELSE
         WRITE(6,*) ' Warning, HFSCAL: INFIN=',INFIN,' not allowed'
         STOP
      ENDIF

      RETURN
      END

C ********************************************************************

      SUBROUTINE HFSSPA(IPU1,IPU2)

C...NEW X REDEFINITION
C...GENERATES SPACELIKE PARTON SHOWERS
      COMMON /LEPTOU/ CUT(14),LST(40),PARL(30),XLP,YLP,W2LP,Q2LP,ULP
      COMMON/LUJETS/N,K(4000,5),SP(4000,5),V(4000,5)
      COMMON/LUDAT1/MSTU(200),PARU(200),MSTJ(200),PARJ(200)
      COMMON/LUDAT2/KCHG(500,3),PMAS(500,4),PARF(2000),VCKM(4,4)
      COMMON /LYPARA/ IPY(80),PYPAR(80),PYVAR(80)
      COMMON /LYPROC/ ISUB,KFL(3,2),X(2),SH,TH,UH,Q2,XSEC(0:40)
      COMMON /LYINT1/ XQ(2,-6:6),DSIG(-6:6,-6:6,5),FSIG(10,10,3)
      DIMENSION IFLS(4),IS(2),XS(2),ZS(2),Q2S(2),TEVS(2),
     &XFS(2,-6:6),XFA(-6:6),XFB(-6:6),WTAP(-6:6),WTSF(-6:6)
      DOUBLE PRECISION DQ2(3),DSH,DSHZ,DSHR,DPLCM,DPC(3),DPD(4),DMS,
     &DMSMA,DPT2,DPB(4),DBE1(4),DBE2(4),DBEP,DGABEP,DPQ(4),DPQS(2),
     &DM2,DQ2B,DROBO(5),DBEZ
C-GI &DQ23,DPH(4),DQM2

CJR    changes for AROMA
      COMMON /HFSNCO/ DX,DQ2EM,DW2,DY,DSEP,DETA,DSHAT
      REAL*8 DX,DQ2EM,DW2,DY,DSEP,DETA,DSHAT
      REAL*8 P
      COMMON /HFJETS/P(4000,5)
      REAL*8 Q2E,TMAX,Q2HARD,XE0,B0,XBMIN,XB,Q2B,TEVB,Q2SCAL,
     &XE,WTAPQ,WTSUM,Q2REF,WTRAN,Z,WTZ,XBNEW,RSOFT,ZU,Q2MAX,ALPRAT,
     &XA,WHAD,A11,PITE,AM2,BM2,AQ3,DTHE
      REAL*8 DE2,DPZ2,DDIF2
      REAL*8 XS,ZS,Q2S,TEVS,XFS,WTAP,WTSF

      REAL*8 HFANGL

      DATA NCOUNT/0/,NPR/0/,NTST/0/,IFLA,NQ/0,0/
      DATA Z,XE0,XA/3*0.D0/,DSHZ,DMSMA,DPT2,DSHR/4*0.D0/,WHAD/0.D0/
      SAVE NCOUNT

      NCOUNT=NCOUNT+1

C14
      DO 888 I=1,N
        DO 889 J=1,5
  889   P(I,J)=SP(I,J)
  888 CONTINUE
C14


C...COMMON CONSTANTS, SET UP INITIAL VALUES
      ILEP=0
      IF(IPU1.EQ.0) ILEP=1
      IF(IPU2.EQ.0) ILEP=2
      Q2E=Q2
C-GI  IF(ISET(ISUB).EQ.2.OR.ISET(ISUB).EQ.3) Q2E=Q2E/PYPAR(26)
      IF(ISUB.EQ.27) Q2E=PMAS(23,1)**2
      IF(ISUB.EQ.28) Q2E=PMAS(24,1)**2
      TMAX=LOG(PYPAR(26)*PYPAR(27)*Q2E/PYPAR(21)**2)
      IF(ILEP.GE.1) THEN
        SH=P(25,5)**2
        IF(N.GE.27) SH=P(27,5)**2
        CALL HFSCAL(-1,QMAX)
        Q2E=QMAX**2
        Q2E=MAX(DBLE(PYPAR(21)**2),
     & MIN(Q2E,(0.95D0/X(3-ILEP)-1.D0)*Q2-SH,DBLE(Q2/2.+SH)))
        TMAX=LOG(Q2E/PYPAR(21)**2)
      ENDIF
C14
      IF(ILEP.EQ.0) THEN
        Q2HARD=PYPAR(26)*Q2E
      ELSE
        Q2HARD=Q2E
      ENDIF
C14   IF(PYPAR(26)*Q2E.LT.MAX(PYPAR(22),2.*PYPAR(21)**2).OR.
C14  &TMAX.LT.0.2) RETURN
      IF(Q2HARD       .LT.MAX(PYPAR(22),2.*PYPAR(21)**2).OR.
     &TMAX.LT.0.2) RETURN
C14

      IF(ILEP.EQ.0) XE0=2.*PYPAR(23)/PYVAR(1)
      B0=(33.-2.*IPY(8))/6.
      NS=N
      MSTU(2)=0
  100 N=NS
      IF(ILEP.GE.1) THEN
        NQ=IPU2-2
        IF(ILEP.EQ.2) NQ=IPU1+2
C14        DPQS(1)=DBLE(SP(NQ,3))
C14        DPQS(2)=DBLE(SP(NQ,4))
        DPQS(1)=(DW2+DQ2EM)/(2D0*DSQRT(DW2))
        DPQS(2)=(DW2-DQ2EM)/(2D0*DSQRT(DW2))
        P(NQ,3)=DPQS(1)
        P(NQ,4)=DPQS(2)
        P(NQ,1)=0.D0
        P(NQ,2)=0.D0
        XBMIN=X(3-ILEP)*MAX(0.5,SH/Q2)
        CALL LYSTFU(IPY(43-ILEP),SNGL(XBMIN),SNGL(Q2E),XFB)
C14     CALL LYSTFU(IPY(43-ILEP),SNGL(XBMIN),Q2,XFB)
        DO 110 IFL=-6,6
  110   XQ(3-ILEP,IFL)=XFB(IFL)
      ENDIF
      DO 120 JT=1,2
      IFLS(JT)=KFL(2,JT)
      IF(KFL(2,JT).EQ.21) IFLS(JT)=0
      IFLS(JT+2)=IFLS(JT)
      XS(JT)=X(JT)
      ZS(JT)=1.
      IF(ILEP.EQ.0) Q2S(JT)=PYPAR(26)*Q2E
      TEVS(JT)=TMAX
      DO 120 IFL=-6,6
  120 XFS(JT,IFL)=XQ(JT,IFL)
      IF(ILEP.GE.1) THEN
        Q2S(ILEP)=P(NQ,5)**2
        DQ2(ILEP)=Q2S(ILEP)
        Q2S(3-ILEP)=Q2E
      ENDIF
      DSH=SH
      IHFC=0
      IHFX=0

C...PICK UP LEG WITH HIGHEST VIRTUALITY
  130 CONTINUE
      IF(N.GT.MSTU(4)-10) THEN
        WRITE(6,*) ' HFSSPA: no more memory in LUJETS'
        LST(21)=911
        RETURN
      ENDIF
      DO 133 I=N+1,N+8
      DO 133 J=1,5
      K(I,J)=0
  133 P(I,J)=0.
      DO 187 I=1,N
        DO 186 J=1,5
  186   SP(I,J)=P(I,J)
  187 CONTINUE
C      CALL GULIST(21,1)
      N=N+2
      JT=1
      IF((N.GT.NS+2.AND.Q2S(2).GT.Q2S(1).AND.ILEP.EQ.0).OR.ILEP.EQ.1)
     &JT=2
      JR=3-JT
      IFLB=IFLS(JT)
      XB=XS(JT)
      IF(ILEP.GE.1.AND.N.EQ.NS+2) XB=XS(JT)*MAX(SH/Q2,0.5)
      DO 140 IFL=-6,6
  140 XFB(IFL)=XFS(JT,IFL)
      Q2B=Q2S(JT)
      TEVB=TEVS(JT)
      IF(IPY(14).GE.9.AND.N.GT.NS+4) THEN
        Q2B=0.5*(1./ZS(JT)+1.)*Q2S(JT)+0.5*(1./ZS(JT)-1.)*(Q2S(3-JT)-
     &  SNGL(DSH)+SQRT((SNGL(DSH)+Q2S(1)+Q2S(2))**2+8.*Q2S(1)*Q2S(2)*
     &  ZS(JT)/(1.-ZS(JT))))
C14
        IF(ILEP.EQ.0) THEN
          Q2SCAL=PYPAR(27)*Q2B
        ELSE
          Q2SCAL=Q2B
        ENDIF
C14     TEVB=ALOG(PYPAR(27)*Q2B/PYPAR(21)**2)
        TEVB=DLOG(Q2SCAL       /PYPAR(21)**2)
C14
      ENDIF
      IF(ILEP.EQ.0) THEN
        DSHR=2.*DSQRT(DSH)
        DSHZ=DSH/ZS(JT)
      ELSEIF(ILEP.GE.1) THEN
        DSHZ=DSH
        IF(N.GT.NS+4) DSHZ=(DSH+DQ2(JR)-DQ2(JT))/ZS(JT)-DQ2(JR)+
     &  PYPAR(22)
        DPD(2)=DSHZ+DQ2(JR)+DBLE(PYPAR(22))

        QMASS=ULMASS(IABS(IFLB))
        IF(IABS(IFLB).EQ.0) QMASS=ULMASS(21)
C...CHECK IF QUARK PAIR CREATION ONLY POSSIBILITY
C14     IF(DQ2(JR).LT.4.*ULMASS(IABS(IFLB))**2) THEN
C14       DM2=ULMASS(IABS(IFLB))**2
C14       DPC(1)=DQ2(JR)*(DBLE(PYPAR(22))+DM2)**2
C14       DPC(2)=DPD(2)*(DPD(2)-2D0*PYPAR(22))*(PYPAR(22)+DM2)
C14       DPC(3)=PYPAR(22)*(DPD(2)-2D0*PYPAR(22))**2
C14       XE0=1D0-(DPC(2)-DSQRT(DPC(2)**2-4D0*DPC(1)*DPC(3)))/
C14  &    (2D0*DPC(1))
C14     ELSE
C14       XE0=1D0-(DPD(2)-2D0*DBLE(PYPAR(22)))*(DPD(2)-DSQRT(DPD(2)**2-
C14  &    4D0*DQ2(JR)*DBLE(PYPAR(22))))/(2D0*DQ2(JR)*DBLE(PYPAR(22)))
C14     ENDIF
C14
      DM2=ULMASS(IABS(IFLB))**2
C14   XE1=1D0-2D0*DBLE(PYPAR(22))*(DPD(2)-2D0*DBLE(PYPAR(22)))
      XE0=1D0-2D0*DBLE(PYPAR(22))*(DPD(2)-2D0*DBLE(PYPAR(22)))
     &    /((DBLE(PYPAR(22))+DM2)*(DPD(2)+DSQRT(DPD(2)**2-
     &    4D0*DQ2(JR)*DBLE(PYPAR(22)))))
C14   WRITE(6,*) ' XE0 = ',XE0
C14   WRITE(6,*) ' XE1 = ',XE1
C14
CJR--begin (cf. ZU=)
      ZMAX=2D0*DBLE(PYPAR(22))*(DPD(2)-2D0*DBLE(PYPAR(22)))
     &    /((DBLE(PYPAR(22))+DM2)*(DPD(2)+DSQRT(DPD(2)**2-
     &    4D0*DQ2(JR)*DBLE(PYPAR(22)))))
      XE0=XB*(1.D0/ZMAX-1.D0)
CJR--end
      ENDIF
  145 XE=MAX(XE0,XB*(1./(1.-PYPAR(24))-1.))
      IF(XB+XE.GE.0.999) THEN
        Q2B=0.
C14
        DQ2B=0.
        IF(N.GT.NS+4) DSHZ=(DSH+DQ2(JR)-DQ2(JT))/ZS(JT)-DQ2(JR)
C14
        GOTO 210
      ENDIF

C...CALCULATE ALTARELLI-PARISI AND STRUCTURE FUNCTION WEIGHTS
      DO 150 IFL=-6,6
      WTAP(IFL)=0.
  150 WTSF(IFL)=0.
      IF(IFLB.EQ.0) THEN
        WTAPQ=16.*(1.-SQRT(XB+XE))/(3.*SQRT(XB))
        DO 160 IFL=-IPY(8),IPY(8)
        IF(IFL.EQ.0) WTAP(IFL)=6.*LOG((1.-XB)/XE)
  160   IF(IFL.NE.0) WTAP(IFL)=WTAPQ
      ELSE
        WTAP(0)=0.5*XB*(1./(XB+XE)-1.)
        WTAP(IFLB)=8.*LOG((1.-XB)*(XB+XE)/XE)/3.
      ENDIF
  170 WTSUM=0.
      IF(IHFC.EQ.0) THEN
        DO 180 IFL=-IPY(8),IPY(8)
        WTSF(IFL)=XFB(IFL)/MAX(1E-10,XFB(IFLB))
  180   WTSUM=WTSUM+WTAP(IFL)*WTSF(IFL)
        IF(IABS(IFLB).GE.4.AND.WTSUM.GT.1D3) THEN
          IHFX=1
          DO 185 IFL=-IPY(8),IPY(8)
  185     WTSF(IFL)=WTSF(IFL)*1D3/WTSUM
          WTSUM=1D3
        ENDIF
      ENDIF

C...CHOOSE NEW T AND FLAVOUR
  190 IF(IPY(14).LE.6.OR.IPY(14).GE.9) THEN
        TEVXP=B0/MAX(0.0001D0,WTSUM)
      ELSE
        TEVXP=B0/MAX(0.0001D0,5.D0*WTSUM)
      ENDIF
      TEVB=TEVB*EXP(MAX(-100.,LOG(RLU(0))*TEVXP))
C14
      Q2REF=PYPAR(21)**2*EXP(TEVB)
C14   Q2REF=PYPAR(21)**2*EXP(TEVB)/PYPAR(27)
C14
      IF(ILEP.EQ.0) THEN
        Q2B=Q2REF/PYPAR(27)
      ELSE
        Q2B=Q2REF
      ENDIF
C14   Q2B=Q2REF/PYPAR(27)

      DQ2B=Q2B
      IF(ILEP.GE.1) THEN
        DSHZ=DSH
        IF(N.GT.NS+4) DSHZ=(DSH+DQ2(JR)-DQ2(JT))/DBLE(ZS(JT))-DQ2(JR)+
     &  DQ2B
      ENDIF
      IF(Q2B.LT.PYPAR(22)) THEN
        Q2B=0.
C14
        DQ2B=0.
        IF(N.GT.NS+4) DSHZ=(DSH+DQ2(JR)-DQ2(JT))/ZS(JT)-DQ2(JR)
C14

      ELSE
        WTRAN=RLU(0)*WTSUM
        IFLA=-IPY(8)-1
  200   IFLA=IFLA+1
        WTRAN=WTRAN-WTAP(IFLA)*WTSF(IFLA)
        IF(IFLA.LT.IPY(8).AND.WTRAN.GT.0.) GOTO 200

C...CHOOSE Z VALUE AND CORRECTIVE WEIGHT
        IF(IFLB.EQ.0.AND.IFLA.EQ.0) THEN
          Z=1./(1.+((1.-XB)/XB)*(XE/(1.-XB))**RLU(0))
          WTZ=(1.-Z*(1.-Z))**2
        ELSEIF(IFLB.EQ.0) THEN
          Z=XB/(1.-RLU(0)*(1.-SQRT(XB+XE)))**2
          WTZ=0.5*(1.+(1.-Z)**2)*SQRT(Z)
        ELSEIF(IFLA.EQ.0) THEN
          Z=XB*(1.+RLU(0)*(1./(XB+XE)-1.))
          WTZ=1.-2.*Z*(1.-Z)
        ELSE
          Z=1.-(1.-XB)*(XE/((XB+XE)*(1.-XB)))**RLU(0)
          WTZ=0.5*(1.+Z**2)
        ENDIF

C...REWEIGHT FIRST LEG BECAUSE OF MODIFIED XB OR CHECK PHASE SPACE
        IF(ILEP.GE.1.AND.N.EQ.NS+2) THEN
          XBNEW=X(JT)*(1.+(DSH-Q2B)/DQ2(JR))
          IF(XBNEW.GT.MIN(Z,0.999D0)) GOTO 190
          XB=XBNEW
        ENDIF

C...SUM UP SOFT GLUON EMISSION AS EFFECTIVE Z SHIFT
        IF(IPY(15).GE.1) THEN
          RSOFT=6.
          IF(IFLB.NE.0) RSOFT=8./3.
          Z=Z*(TEVB/TEVS(JT))**(RSOFT*XE/((XB+XE)*B0))
          IF(Z.LE.XB) GOTO 190
        ENDIF

C...CHECK IF HEAVY FLAVOUR BELOW THRESHOLD
        IHFT=0
        IF(ILEP.GE.1.AND.IABS(IFLB).GE.4.AND.(XFB(IFLB).LT.1E-10.OR.
     &    Q2B.LT.5.*ULMASS(IABS(IFLB))**2)) THEN
          IHFT=1
          IFLA=0
        ENDIF

C...FOR LEPTOPRODUCTION, CHECK Z AGAINST NEW LIMIT
        IF(ILEP.GE.1) THEN
          DPD(2)=DSHZ+DQ2(JR)+DQ2B
          DM2=ULMASS(IABS(IFLA-IFLB))**2
          IF(IABS(IFLA-IFLB).EQ.0) DM2=ULMASS(21)**2
C14          DPC(1)=DQ2(JR)*(DQ2B+DM2)**2
C14          DPC(2)=DPD(2)*(DPD(2)-2D0*DQ2B)*(DQ2B+DM2)
C14          DPC(3)=DQ2B*(DPD(2)-2D0*DQ2B)**2
C14          ZU=(DPC(2)-DSQRT(DPC(2)**2-4D0*DPC(1)*DPC(3)))/(2D0*DPC(1))
C14       XE1=2D0*DQ2B*(DPD(2)-2D0*DQ2B)
          ZU=2D0*DQ2B*(DPD(2)-2D0*DQ2B)
     &      /((DQ2B+DM2)*(DPD(2)+DSQRT(DPD(2)**2-
     &      4D0*DQ2(JR)*DQ2B)))

          IF(Z.GE.ZU) GOTO 190
        ENDIF

C...OPTION WITH EVOLUTION IN KT2=(1-Z)Q2:
        IF(IPY(14).GE.5.AND.IPY(14).LE.6.AND.N.LE.NS+4) THEN
C...CHECK THAT (Q2)LAST BRANCHING < (Q2)HARD
C14
          IF(ILEP.EQ.0) THEN
            Q2HARD=PYPAR(26)*Q2
          ELSE
            Q2HARD=Q2E
          ENDIF
          IF(Q2B/(1.-Z).GT.Q2HARD      ) GOTO 190
C14       IF(Q2B/(1.-Z).GT.PYPAR(26)*Q2) GOTO 190
        ELSEIF(IPY(14).GE.3.AND.IPY(14).LE.6.AND.N.GE.NS+6) THEN
C...CHECK THAT Z,Q2 COMBINATION IS KINEMATICALLY ALLOWED
          Q2MAX=0.5*(1./ZS(JT)+1.)*DQ2(JT)+0.5*(1./ZS(JT)-1.)*
     &    (DQ2(3-JT)-DSH+SQRT((DSH+DQ2(1)+DQ2(2))**2+8.*DQ2(1)*DQ2(2)*
     &    ZS(JT)/(1.-ZS(JT))))
          IF(Q2B/(1.-Z).GE.Q2MAX) GOTO 190

        ELSEIF(IPY(14).EQ.7.OR.IPY(14).EQ.8) THEN
C...OPTION WITH ALPHAS((1-Z)Q2): DEMAND KT2 > CUTOFF, REWEIGHT
          IF((1.-Z)*Q2B.LT.PYPAR(22)) GOTO 190
          ALPRAT=TEVB/(TEVB+LOG(1.D0-Z))
          IF(ALPRAT.LT.5.*RLU(0)) GOTO 190
          IF(ALPRAT.GT.5.) WTZ=WTZ*ALPRAT/5.
        ENDIF

C...WEIGHTING WITH NEW STRUCTURE FUNCTIONS
        CALL LYSTFU(IPY(40+JT),SNGL(XB),SNGL(Q2REF),XFB)
        XA=XB/Z
        CALL LYSTFU(IPY(40+JT),SNGL(XA),SNGL(Q2REF),XFA)
        IF(IHFT.EQ.1.OR.IHFX.EQ.1) THEN
           IF(XFA(IFLA).LT.1E-10) IHFC=1
           GOTO 210
        ELSEIF(XFB(IFLB).LT.1E-20) THEN
          GOTO 100
        ENDIF
        IF(WTZ*XFA(IFLA)/XFB(IFLB).LT.RLU(0)*WTSF(IFLA)) THEN
          IF(ILEP.GE.1.AND.N.EQ.NS+2) GOTO 145
          GOTO 170
        ENDIF
      ENDIF

  210 IF(N.EQ.NS+4-2*MIN(1,ILEP)) THEN
C...DEFINE TWO HARD SCATTERERS IN THEIR CM-FRAME
        DQ2(JT)=Q2B
        IF(IPY(14).GE.3.AND.IPY(14).LE.6) DQ2(JT)=Q2B/(1.-Z)
        IF(ILEP.EQ.0) THEN
          DPLCM=DSQRT((DSH+DQ2(1)+DQ2(2))**2-4.*DQ2(1)*DQ2(2))/DSHR
          DO 220 JR=1,2
          I=NS+2*JR-1
          IPO=19+2*JR
          K(I,1)=14
          K(I,2)=IFLS(JR+2)
          IF(IFLS(JR+2).EQ.0) K(I,2)=21
          K(I,3)=0
          K(I,4)=IPO
          K(I,5)=IPO
          P(I,1)=0.
          P(I,2)=0.
          P(I,3)=DPLCM*(-1)**(JR+1)
          P(I,4)=(DSH+DQ2(3-JR)-DQ2(JR))/DSHR
          P(I,5)=-SQRT(DQ2(JR))
          K(I+1,1)=-1
          K(I+1,2)=K(IPO+1,2)
          K(I+1,3)=I
          K(I+1,4)=0
          K(I+1,5)=0
          P(I+1,1)=0.
          P(I+1,2)=0.
          P(I+1,3)=IPO
          P(I+1,4)=IPO
          P(I+1,5)=0.
          P(IPO+1,1)=I
          P(IPO+1,2)=I
          K(IPO,4)=MOD(K(IPO,4),MSTU(5))+I*MSTU(5)
          K(IPO,5)=MOD(K(IPO,5),MSTU(5))+I*MSTU(5)
  220     CONTINUE
        ELSE
C..LEPTOPRODUCTION EVENTS: BOSON AND HADRON REST FRAME
          I1=NS+2*ILEP-1
          I2=NS-2*ILEP+5
          DO 225 ITEMP=NS+1,NS+4
          DO 225 J=1,5
          K(ITEMP,J)=0
  225     P(ITEMP,J)=0.
          DO 230 J=1,5
  230     P(I1,J)=P(NQ,J)
          K(NS+1,1)=11
          K(NS+3,1)=14
          IF(ILEP.EQ.2) THEN
            K(NS+1,1)=14
            K(NS+3,1)=11
          ENDIF
          K(NS+2,1)=-1
          K(NS+4,1)=-1
          K(NS+1,3)=0
          K(NS+2,3)=NS+1
          K(NS+3,3)=0
          K(NS+4,3)=NS+3
          K(I1,2)=KFL(2,ILEP)
          K(I2,2)=KFL(2,3-ILEP)
          DPD(1)=DSH+DQ2(1)+DQ2(2)
          DPD(3)=(3-2*ILEP)*DSQRT(DPD(1)**2-4D0*DQ2(1)*DQ2(2))
          WHAD=DSQRT(DW2)
          A11=(DPD(1)+DPD(3))/WHAD
          P(I2,3)=-A11/4.-DQ2(2)/A11
          P(I2,4)=A11/4.-DQ2(2)/A11
          A11=-P(I2,4)**2+P(I2,3)**2
          IF(ABS(DQ2(3-ILEP)-A11).GT.0.05*MAX(DQ2(3-ILEP),A11)) THEN
CJR            WRITE(6,*) ' Warning from HFSSPA: Q1S badly calculated'
CJR            WRITE(6,*) ' -E1**2+P1Z**2, Q1**2 = ',A11,DQ2(3-ILEP)
CJR--         return with error flag !
             LST(21)=912
             RETURN
          ENDIF
          A11=-P(I1,4)**2+P(I1,3)**2
          IF(ABS(DQ2(JR)-A11).GT.0.05*MAX(DQ2(JR),A11)) THEN
CJR            WRITE(6,*) ' Warning from HFSSPA: Q2 badly calculated'
CJR            WRITE(6,*) ' -Q0**2+QZ**2, Q**2   = ',A11,DQ2(JR)
CJR--         return with error flag !
             LST(21)=913
             RETURN
          ENDIF


          P(I2,5)=-SQRT(DQ2(3-ILEP))
          P(I2+1,3)=MAX(IPU1,IPU2)
          P(I2+1,4)=MAX(IPU1,IPU2)
          K(I2,4)=K(I2,4)-MOD(K(I2,4),MSTU(5))+MAX(IPU1,IPU2)
          K(I2,5)=K(I2,5)-MOD(K(I2,5),MSTU(5))+MAX(IPU1,IPU2)
          P(26-2*ILEP,1)=I2
          P(26-2*ILEP,2)=I2
          K(25-2*ILEP,4)=MOD(K(25-2*ILEP,4),MSTU(5))+I2*MSTU(5)
          K(25-2*ILEP,5)=MOD(K(25-2*ILEP,5),MSTU(5))+I2*MSTU(5)
          N=N+2
        ENDIF

      ELSEIF(N.GT.NS+4) THEN
C...FIND MAXIMUM ALLOWED MASS OF TIMELIKE PARTON
        DQ2(3)=Q2B
        IF(IPY(14).GE.3.AND.IPY(14).LE.6) DQ2(3)=Q2B/(1.-Z)
        IF(IS(1).GE.1.AND.IS(1).LE.MSTU(4)) THEN
          DPC(1)=P(IS(1),4)
          DPC(3)=0.5*(ABS(P(IS(1),3))+ABS(P(IS(2),3)))
        ELSE
C...IS(1) not initialized
          DPC(1)=0.
          DPC(3)=0.5*(       0.      +ABS(P(IS(2),3)))
        ENDIF
        DPC(2)=P(IS(2),4)
        DPD(1)=DSH+DQ2(JR)+DQ2(JT)
        DPD(2)=DSHZ+DQ2(JR)+DQ2(3)
        DPD(3)=DSQRT(DPD(1)**2-4.*DQ2(JR)*DQ2(JT))
        DPD(4)=DSQRT(DPD(2)**2-4.*DQ2(JR)*DQ2(3))
        IKIN=0
        IF((Q2S(JR).GE.0.5*PYPAR(22).AND.DPD(1)-DPD(3).GE.1D-10*DPD(1))
     &  .OR.ILEP.GE.1) IKIN=1
        IF(IKIN.EQ.0) DMSMA=(DQ2(JT)/ZS(JT)-DQ2(3))*(DSH/
     &  (DSH+DQ2(JT))-DSH/(DSHZ+DQ2(3)))
C14
        IF(IKIN.EQ.1.AND.ILEP.GE.1) THEN
          DMSMA=(DPD(1)+DPD(3))/(DPD(2)+DPD(4))
          DMSMA=DQ2(3)*(DMSMA-1D0)+DQ2(JT)*(1D0/DMSMA-1D0)
C14       WRITE(6,*) ' DMSMA = ',DMSMA
C14       DMSMA=(DPD(1)*DPD(2)-DPD(3)*DPD(4))/(2.*
C14  &    DQ2(JR))-DQ2(JT)-DQ2(3)
C14       WRITE(6,*) ' DMSMA = ',DMSMA
        ELSE
          DMSMA=(DPD(1)*DPD(2)-DPD(3)*DPD(4))/(2.*
     &    DQ2(JR))-DQ2(JT)-DQ2(3)
        ENDIF
C14     IF(IKIN.EQ.1) DMSMA=(DPD(1)*DPD(2)-DPD(3)*DPD(4))/(2.*
C14  &  DQ2(JR))-DQ2(JT)-DQ2(3)

C...GENERATE TIMELIKE PARTON SHOWER (IF REQUIRED)
        IT=N-1
        K(IT,1)=3
        K(IT,2)=IFLB-IFLS(JT+2)
        IF(IFLB-IFLS(JT+2).EQ.0) K(IT,2)=21
        P(IT,5)=ULMASS(K(IT,2))
        IF(DMSMA.LE.P(IT,5)**2) GOTO 100
        P(IT,2)=0.
        DO 240 J=1,5
        K(IT+1,J)=0
  240   P(IT+1,J)=0.
        K(IT+1,1)=-1
        K(IT+1,2)=K(IS(JT)+1,2)
        K(IT+1,3)=IT
        IF(MOD(IPY(14),2).EQ.0) THEN
          P(IT,1)=0.
          IF(ILEP.EQ.0) P(IT,4)=(DSHZ-DSH-P(IT,5)**2)/DSHR

C14
          IF(ILEP.GE.1) THEN
            PITE=0.5*(P(IS(JT),3)*DPD(2)
     &                +DPQS(1)*(DQ2(JT)+DQ2(3)+P(IT,5)**2))
            P(IT,4)=PITE/(P(IS(JT),3)*DPQS(2)-P(IS(JT),4)*DPQS(1))
     &             -DPC(JT)
C14         PITE=PITE/(DQ2(JT)*DQ2(JR)/(DPD(1)+DPD(3))
C    &                             -(DPD(1)+DPD(3))/4D0)
C    &          -DPC(JT)
C           IF(NCOUNT.LE.NPR) WRITE(6,*) ' P(IT,4), PITE = ',
C    &        P(IT,4),PITE
C           IF(ABS((P(IT,4)-PITE)/P(IT,4)).GE.0.05) THEN
C             WRITE(6,*) 'Warning from HFSSPA: P(IT,4) badly calculated'
C             WRITE(6,*) ' P(IT,4), PITE = ',P(IT,4),PITE
C14         ENDIF
          DMS=P(IT,5)**2
          DPT2=0D0
C14       DDIF2=(
C    &     (1D0-ZS(JT))/ZS(JT)*(DPD(1)-2D0*DQ2(JT))*(DPD(1)+DPD(3))/2D0
C    &    -(DQ2(JT)-DQ2B)*(DPD(1)+DPD(3)-DQ2(JR)) - DQ2(JR)*DMS
C    &          )/(DPD(3)*WHAD)
C         DE2=0.5D0*(DDIF2+(DMS+DPT2)/DDIF2)
C         DPZ2=0.5D0*(-DDIF2+(DMS+DPT2)/DDIF2)
C         AM2=P(IT,4)**2-P(IT,3)**2-P(IT,1)**2
C         BM2=DE2**2-DPZ2**2-DPT2
C         IF(NCOUNT.LE.NPR)
C    &     WRITE(6,*) ' M2**2, P2**2 = ',DMS,BM2
C         IF(ABS(P(IT,4)-DE2).GE.MAX(0.05*DE2,1D-2)) THEN
C           WRITE(6,*) ' Warning from HFSSPA: P(IT,4) badly calculated'
C           WRITE(6,*) ' M2**2, P2**2 = ',DMS,BM2
C           WRITE(6,*) ' DPT2, DMSMA = ',DPT2,DMSMA
C           WRITE(6,*) ' E2, E2NEW = ',P(IT,4),DE2
C           WRITE(6,*) ' E2+P2Z = ',(DMS+DPT2)/DDIF2
C           WRITE(6,*) ' E2-P2Z = ',DDIF2
C         ENDIF
          DDIF2=-((DPD(1)+DPD(3))*(DPD(3)-DPD(2))/(4D0*WHAD)
     &    -WHAD*DQ2(JT)*(DPD(3)-DPD(1)+2D0*DPD(2))/(2D0*(DPD(1)+DPD(3)))
     &    +WHAD*(DQ2B+DMS)/2D0
     &    +Q2*(DQ2(JT)+DQ2B+DMS)/(2D0*WHAD)
     &          )/DPD(3)
C         AM2=P(IT,4)**2-P(IT,3)**2-P(IT,1)**2
C          IF(NCOUNT.LE.NPR)
C     &     WRITE(6,*) ' E2, E2NEW = ',P(IT,4),DDIF2
C    &     WRITE(6,*) ' E2, E2OLD, E2NEW = ',P(IT,4),DE2,DDIF2
          IF(ABS(P(IT,4)-DDIF2).GE.MAX(0.05D0*DDIF2,1.D-2)) THEN
CJR            WRITE(6,*) ' Warning from HFSSPA: P(IT,4) badly calculated'
CJR            WRITE(6,*) ' E2, E2NEW = ',P(IT,4),DDIF2
CJR--         return with error flag !
             LST(21)=914
             RETURN
          ENDIF

          ENDIF
C14       IF(ILEP.GE.1) P(IT,4)=0.5*(P(IS(JT),3)*DPD(2)+
C14  &    DPQS(1)*(DQ2(JT)+DQ2(3)+P(IT,5)**2))/(P(IS(JT),3)*DPQS(2)-
C14  &    P(IS(JT),4)*DPQS(1))-DPC(JT)
          P(IT,3)=SQRT(P(IT,4)**2-P(IT,5)**2)
C14
          DO 666 J=1,5
            SP(IT,J)=P(IT,J)
  666       SP(IT+1,J)=P(IT+1,J)
C14
          CALL LUSHOW(IT,0,SQRT(MIN(SNGL(DMSMA),PYPAR(25)*SNGL(Q2E))))
C14       CALL LUSHOW(IT,0,SQRT(MIN(SNGL(DMSMA),PYPAR(25)*Q2)))
C14
          IF(N.GE.IT+2) THEN
            DO 668 I=IT,N
              DO 667 J=1,5
  667         P(I,J)=SP(I,J)
  668       CONTINUE
          ENDIF
C14

          IF(N.GE.IT+2) P(IT,5)=P(IT+2,5)
          IF(N.GT.MSTU(4)-10) THEN
            WRITE(6,*) ' HFSSPA: no more memory in LUJETS'
            LST(21)=915
            RETURN
          ENDIF
          DO 243 I=N+1,N+8
          DO 243 J=1,5
          K(I,J)=0
  243     P(I,J)=0.D0
        ENDIF

C...RECONSTRUCT KINEMATICS OF BRANCHING: TIMELIKE PARTON SHOWER
        DMS=P(IT,5)**2
        IF(IKIN.EQ.0.AND.ILEP.EQ.0) DPT2=(DMSMA-DMS)*(DSHZ+DQ2(3))/
     &  (DSH+DQ2(JT))
        IF(IKIN.EQ.1.AND.ILEP.EQ.0) DPT2=(DMSMA-DMS)*(0.5*DPD(1)*
     &  DPD(2)+0.5*DPD(3)*DPD(4)-DQ2(JR)*(DQ2(JT)+DQ2(3)+DMS))/
     &  (4.*DSH*DPC(3)**2)
C14        IF(IKIN.EQ.1.AND.ILEP.GE.1) DPT2=(DMSMA-DMS)*(0.5*DPD(1)*
C14     &  DPD(2)+0.5*DPD(3)*DPD(4)-DQ2(JR)*(DQ2(JT)+DQ2(3)+DMS))/
C14     &  DPD(3)**2
        IF(IKIN.EQ.1.AND.ILEP.GE.1) THEN
          DPT2=(DMSMA-DMS)*(0.5*DPD(1)*
     &    DPD(2)+0.5*DPD(3)*DPD(4)-DQ2(JR)*(DQ2(JT)+DQ2(3)+DMS))/
     &    DPD(3)**2
        ENDIF
        IF(DPT2.LT.0.) GOTO 100
        K(IT,3)=N+1
        P(IT,1)=SQRT(DPT2)
        IF(ILEP.EQ.0) THEN
          DPB(1)=(0.5*DPD(2)-DPC(JR)*(DSHZ+DQ2(JR)-DQ2(JT)-DMS)/
     &    DSHR)/DPC(3)-DPC(3)
          P(IT,3)=DPB(1)*(-1)**(JT+1)
          P(IT,4)=(DSHZ-DSH-DMS)/DSHR
        ELSE
          DPC(3)=DQ2(JT)+DQ2(3)+DMS
          DPB(2)=DPQS(2)*P(IS(JT),3)-DPQS(1)*DPC(JT)
          DPB(1)=0.5D0*(DPC(JT)*DPD(2)+DPQS(2)*DPC(3))/DPB(2)-
     &    P(IS(JT),3)
          P(IT,3)=DPB(1)
          P(IT,4)=0.5D0*(P(IS(JT),3)*DPD(2)+
     &    DPQS(1)*DPC(3))/DPB(2)-DPC(JT)
C14
          DDIF2=(
     &     (1D0-ZS(JT))/ZS(JT)*(DPD(1)-2D0*DQ2(JT))*(DPD(1)+DPD(3))/2D0
     &    -(DQ2(JT)-DQ2B)*(DPD(1)+DPD(3)-DQ2(JR)) - DQ2(JR)*DMS
     &          )/(DPD(3)*WHAD)
          DE2=0.5D0*(DDIF2+(DMS+DPT2)/DDIF2)
          DPZ2=0.5D0*(-DDIF2+(DMS+DPT2)/DDIF2)
          AM2=P(IT,4)**2-P(IT,3)**2-P(IT,1)**2
          BM2=DE2**2-DPZ2**2-DPT2
C          IF(NCOUNT.LE.NPR)
C     &     WRITE(6,*) ' M2**2, P2**2 = ',DMS,AM2
          IF(ABS(DMS-AM2).GE.MAX(0.05*DMS,1D-2)) THEN
CJR            WRITE(6,*) ' Warning from HFSSPA: m2 badly calculated'
CJR            WRITE(6,*) ' M2**2, P2**2, P2**2NEW = ',DMS,AM2,BM2
CJR            WRITE(6,*) ' DPT2, DMSMA = ',DPT2,DMSMA
CJR            WRITE(6,*) ' E2+P2Z = ',(DMS+DPT2)/DDIF2,P(IT,4)+P(IT,3)
CJR            WRITE(6,*) ' E2-P2Z = ',DDIF2,P(IT,4)-P(IT,3)
CJR--         return with error flag !
             LST(21)=916
             RETURN
          ENDIF
          P(IT,3)=DPZ2
          P(IT,4)=DE2
C14

        ENDIF
        IF(N.GE.IT+2) THEN
C          WRITE(6,*) 'N,IT',N,IT
          MSTU(1)=IT+2
          DPB(1)=DSQRT(DPB(1)**2+DPT2)
          DPB(2)=DSQRT(DPB(1)**2+DMS)
          DPB(3)=P(IT+2,3)
          DPB(4)=DSQRT(DPB(3)**2+DMS)
          DBEZ=(DPB(4)*DPB(1)-DPB(3)*DPB(2))/(DPB(4)*DPB(2)-DPB(3)*
     &    DPB(1))
C          WRITE(6,*) 'DPB,DBEZ',DPB(1),DPB(2),DPB(3),DPB(4),DBEZ
          CALL HFDBRB(MSTU(1),MSTU(2),0.D0,0.D0,0.D0,0.D0,DBEZ)
          DTHE=HFANGL(P(IT,3),P(IT,1))
C          WRITE(6,*) 'DTHE',DTHE
          CALL HFDBRB(MSTU(1),MSTU(2),DTHE,0.D0,0.D0,0.D0,0.D0)
      DO 387 I=1,N
        DO 386 J=1,5
  386   SP(I,J)=P(I,J)
  387 CONTINUE
C      CALL GULIST(121,1)

        ENDIF

C...RECONSTRUCT KINEMATICS OF BRANCHING: SPACELIKE PARTON
        K(N+1,1)=14
        K(N+1,2)=IFLB
        IF(IFLB.EQ.0) K(N+1,2)=21
        K(N+1,3)=0
        P(N+1,1)=P(IT,1)
        P(N+1,2)=0.
        P(N+1,3)=P(IT,3)+P(IS(JT),3)
        P(N+1,4)=P(IT,4)+P(IS(JT),4)
        P(N+1,5)=-SQRT(DQ2(3))
C14
        AQ3=-(P(N+1,4)**2-P(N+1,3)**2-P(N+1,1)**2)
C        IF(NCOUNT.LE.NPR)
C     &   WRITE(6,*) ' Q3**2, -P3**2 = ',DQ2(3),AQ3
        IF(ABS(DQ2(3)-AQ3).GE.MAX(5D-2*DQ2(3),1D-2)) THEN
CJR          WRITE(6,*) ' Warning from HFSSPA: Q3**2 badly calculated'
CJR          WRITE(6,*) ' Q3**2, -P3**2 = ',DQ2(3),AQ3
CJR          WRITE(6,*) ' E2**2-P2Z**2 = ',P(IT,4)**2-P(IT,3)**2,DMS+DPT2
CJR          WRITE(6,*) ' E1**2-P1Z**2 = ',P(IS(JT),4)**2-P(IS(JT),3)**2
CJR     &                                     ,-DQ2(JT)
CJR--         return with error flag !
             LST(21)=917
             RETURN
        ENDIF
C14

        DO 250 J=1,5
        K(N+2,J)=0
  250   P(N+2,J)=0.
        K(N+2,1)=-1
        K(N+2,2)=K(IS(JT)+1,2)
        K(N+2,3)=N+1

C...DEFINE COLOUR FLOW OF BRANCHING
        K(IS(JT),1)=14
        K(IS(JT),3)=N+1
        ID1=IT
      KN1=ISIGN(500+IABS(K(N+1,2)),2*K(N+1,2)+1)
      KD1=ISIGN(500+IABS(K(ID1,2)),2*K(ID1,2)+1)
      IF(K(N+1,2).EQ.21) KN1=500
      IF(K(ID1,2).EQ.21) KD1=500
        IF((KN1.GE.501.AND.KD1.GE.501).OR.(KN1.LT.0.AND.
     &  KD1.EQ.500).OR.(KN1.EQ.500.AND.KD1.EQ.500.AND.
     &  RLU(0).GT.0.5).OR.(KN1.EQ.500.AND.KD1.LT.0))
     &  ID1=IS(JT)
        ID2=IT+IS(JT)-ID1
        P(N+2,3)=ID1
        P(N+2,4)=ID2
        P(ID1+1,1)=N+1
        P(ID1+1,2)=ID2
        P(ID2+1,1)=ID1
        P(ID2+1,2)=N+1
        K(N+1,4)=K(N+1,4)-MOD(K(N+1,4),MSTU(5))+ID1
        K(N+1,5)=K(N+1,5)-MOD(K(N+1,5),MSTU(5))+ID2
        K(ID1,4)=MOD(K(ID1,4),MSTU(5))+(N+1)*MSTU(5)
        K(ID1,5)=MOD(K(ID1,5),MSTU(5))+ID2*MSTU(5)
        K(ID2,4)=MOD(K(ID2,4),MSTU(5))+ID1*MSTU(5)
        K(ID2,5)=MOD(K(ID2,5),MSTU(5))+(N+1)*MSTU(5)
        N=N+2
      DO 287 I=1,N
        DO 286 J=1,5
  286   SP(I,J)=P(I,J)
  287 CONTINUE
C      CALL GULIST(22,1)

C...BOOST TO NEW CM-FRAME
        MSTU(1)=NS+1
        IF(ILEP.EQ.0) THEN
          CALL HFDBRB(MSTU(1),MSTU(2),0.D0,0.D0,
     &    -(P(N-1,1)+P(IS(JR),1))/(P(N-1,4)+P(IS(JR),4)),
     &    0.D0,-(P(N-1,3)+P(IS(JR),3))/(P(N-1,4)+P(IS(JR),4)))
          IR=N-1+(JT-1)*(IS(1)-N+1)
          CALL HFDBRB(MSTU(1),MSTU(2),
     &    -HFANGL(P(IR,3),P(IR,1)),
     &    DBLE(PARU(2)*RLU(0)),0.D0,0.D0,0.D0)
        ELSE
C...REORIENTATE EVENT WITHOUT CHANGING THE BOSON FOUR MOMENTUM
          DO 260 J=1,4
  260     DPQ(J)=P(NQ,J)
          DBE1(4)=DPQ(4)+P(N-1,4)
          DO 270 J=1,3,2
  270     DBE1(J)=-(DPQ(J)+P(N-1,J))/DBE1(4)
          DBE1(4)=1D0/DSQRT(1D0-DBE1(1)**2-DBE1(3)**2)
          DBEP=DBE1(1)*DPQ(1)+DBE1(3)*DPQ(3)
          DGABEP=DBE1(4)*(DBE1(4)*DBEP/(1D0+DBE1(4))+DPQ(4))
          DO 280 J=1,3,2
  280     DPQ(J)=DPQ(J)+DGABEP*DBE1(J)
          DPQ(4)=DBE1(4)*(DPQ(4)+DBEP)
          DPC(1)=DSQRT(DPQ(1)**2+DPQ(3)**2)
          A11=DSQRT(DPQS(2)**2+DPC(1)**2-DPQ(4)**2)
          PITE=DABS(DPQS(1))
          IF(ABS(PITE-A11).GT.1D-4*MIN(PITE,A11)) THEN
CJR            WRITE(6,*) ' Warning from HFSSPA: MOD(Q) badly calculated'
CJR            WRITE(6,*) ' SQRT(Q0**2+QP**2-Q0P**2), Q = ',A11,PITE
CJR--         return with error flag !
             LST(21)=918
             RETURN
          ENDIF
C14       A11=PITE
CJR          DBE2(4)=-(DPQ(4)*DPC(1)-DPQS(2)*A11)/(DPC(1)**2+DPQS(2)**2)
          DBE2(4)=-(DPQ(4)*DPC(1)-DPQS(2)*DSQRT(DPQS(2)**2+DPC(1)**2-
     &              DPQ(4)**2))/(DPC(1)**2+DPQS(2)**2)
          DTHE=HFANGL(DPQ(3),DPQ(1))
          DBE2(1)=DBE2(4)*DSIN(DTHE)
          DBE2(3)=DBE2(4)*DCOS(DTHE)
          DBE2(4)=1.D0/(1.D0-DBE2(4)**2)
C14       DBE2(4)=1.D0/(1.D0-DBE2(1)**2-DBE2(3)*2)


C...CONSTRUCT THE COMBINED BOOST
          DPB(1)=DBE1(4)**2*DBE2(4)/(1D0+DBE1(4))
          DPB(2)=DBE1(1)*DBE2(1)+DBE1(3)*DBE2(3)
          DPB(3)=DBE1(4)*DBE2(4)*(1D0+DPB(2))
          DO 290 JB=1,3,2
  290     DROBO(JB+2)=(DBE1(4)*DBE2(4)*DBE1(JB)+DBE2(4)*DBE2(JB)+
     &    DPB(1)*DBE1(JB)*DPB(2))/DPB(3)
          CALL HFDBRB(MSTU(1),MSTU(2),0.D0,0.D0,DROBO(3),0.D0,DROBO(5))
      DO 687 I=1,N
        DO 686 J=1,5
  686   SP(I,J)=P(I,J)
  687 CONTINUE
C          CALL GULIST(121,1)
          IF(ILEP.EQ.1) DTHE=HFANGL(P(NS+1,3),P(NS+1,1))
          IF(ILEP.EQ.2) DTHE=DBLE(PARU(1))+
     &    HFANGL(P(NS+3,3),P(NS+3,1))
          CALL HFDBRB(MSTU(1),MSTU(2),-DTHE,DBLE(PARU(2)*RLU(0)),
     ,                0.D0,0.D0,0.D0)
      DO 487 I=1,N
        DO 486 J=1,5
  486   SP(I,J)=P(I,J)
  487 CONTINUE

C          CALL GULIST(122,1)
C      CALL GULIST(221,1)

          IF(NCOUNT.LE.NTST) THEN
 2001       FORMAT(1x,4E13.5)
            WRITE(6,2001) DPT2,P(IT,1)**2+P(IT,2)**2,
     &        P(N-1,1)**2+P(N-1,2)**2,P(IS(JT),1)**2+P(IS(JT),2)**2
C           WRITE(6,*) ' X,XB, ZS(JT) = ',X(2),XB, ZS(JT)
C           WRITE(6,*) ' SHAT, W2 = ',DSH,WHAD**2
            S1=DPD(1)
            R1=DPD(3)
            Z1=ZS(JT)
            Z1MAX=2D0*(S1-2D0*DQ2(JT))/(S1+R1)
            Q3SMAX=MIN(2D0*DQ2(JT)*Z1MAX/Z1*(S1+R1-Q2*(1D0-Z1+Z1/Z1MAX))
     &        /(2D0*DSH+Q2-2D0*DQ2(JT)),DW2+Q2)
            WRITE(6,2003)DQ2(3)*(2D0*DW2+Q2)*(Q3SMAX-DQ2(3))/(DW2+Q2)**2
     &       ,DQ2(3)*((DW2+Q2)*(DW2-DSHZ)-DW2*DQ2(3))/(DW2+Q2)**2
     &       ,DPT2*(DPD(3)/DPD(4))**2
 2003       FORMAT(1X,'NEW PT2 = ',3E12.5)
C           WRITE(6,*) ' NEW SHAT = ',DSHZ
C           WRITE(6,*) ' Q2, Q1S, Q3S= ',DQ2(JR),DQ2(JT),DQ2(3)
C           WRITE(6,*) ' S1, S3 = ',DPD(1),DPD(2)
C           WRITE(6,*) ' R1, R3 = ',DPD(3),DPD(4)
          ENDIF
C!        ENDIF
        ENDIF
        MSTU(1)=0
      ENDIF

C...SAVE QUANTITIES, LOOP BACK
      IS(JT)=N-1
      IF(ILEP.EQ.2.AND.N.EQ.NS+4) IS(JT)=N-3
      Q2S(JT)=Q2B
      DQ2(JT)=Q2B
      IF(IPY(14).GE.3.AND.IPY(14).LE.6) DQ2(JT)=Q2B/(1.-Z)
      DSH=DSHZ
      IF(Q2B.GE.0.5*PYPAR(22)) THEN
        IFLS(JT+2)=IFLS(JT)
        IFLS(JT)=IFLA
        XS(JT)=XA
        ZS(JT)=Z
        DO 300 IFL=-6,6
  300   XFS(JT,IFL)=XFA(IFL)
        TEVS(JT)=TEVB
      ELSE
        IF(JT.EQ.1) IPU1=N-1
        IF(JT.EQ.2) IPU2=N-1
      ENDIF
      IF(MAX(IABS(1-ILEP)*Q2S(1),MIN(1,2-ILEP)*Q2S(2)).GE.0.5*PYPAR(22)
     &.OR.N.LE.NS+2) GOTO 130
      IF(ILEP.EQ.0) THEN
C...BOOST HARD SCATTERING PARTONS TO FRAME OF SHOWER INITIATORS
        DO 310 J=1,3
  310   DROBO(J+2)=(P(NS+1,J)+P(NS+3,J))/(P(NS+1,4)+P(NS+3,4))
        DO 320 J=1,5
  320   P(N+2,J)=P(NS+1,J)
        MSTU(1)=N+2
        MSTU(2)=N+2

        CALL HFDBRB(N+2,N+2,0.D0,0.D0,-DROBO(3),-DROBO(4),-DROBO(5))
        DROBO(2)=HFANGL(P(N+2,1),P(N+2,2))
        DROBO(1)=HFANGL(P(N+2,3),SQRT(P(N+2,1)**2+P(N+2,2)**2))
        MSTU(1)=4
        MSTU(2)=NS
        CALL HFDBRB(4,NS,DROBO(1),DROBO(2),DROBO(3),DROBO(4),DROBO(5))
        MSTU(1)=0
        MSTU(2)=0
      ENDIF

C...STORE USER INFORMATION
      K(21,1)=14
      IF(ILEP.NE.0) K(21,1)=11
      K(23,1)=14
      K(21,3)=NS+1
      K(23,3)=NS+3
      DO 330 JT=1,2
      KFL(1,JT)=IFLS(JT)
      IF(IFLS(JT).EQ.0) KFL(1,JT)=21
  330 PYVAR(30+JT)=XS(JT)

      DO 340 I=NS+1,N
      DO 340 J=1,5
  340 V(I,J)=0.
C14
      DO 887 I=1,N
        DO 886 J=1,5
  886   SP(I,J)=P(I,J)
  887 CONTINUE
C14

      RETURN
      END

C*********************************************************************

      DOUBLE PRECISION FUNCTION HFANGL(DX,DY)

      IMPLICIT REAL*8(D)

C--      modification of JETSET73 subroutine to double precision

C...Purpose: to reconstruct an angle from given x and y coordinates.
      COMMON/LUDAT1/MSTU(200),PARU(200),MSTJ(200),PARJ(200)
      SAVE /LUDAT1/

      HFANGL=0.D0
      DR=SQRT(DX**2+DY**2)
      IF(DR.LT.1D-20) RETURN
      IF(ABS(DX)/DR.LT.0.8D0) THEN
        HFANGL=SIGN(ACOS(DX/DR),DY)
      ELSE
        HFANGL=ASIN(DY/DR)
        IF(DX.LT.0.D0.AND.HFANGL.GE.0.D0) THEN
          HFANGL=DBLE(PARU(1))-HFANGL
        ELSEIF(DX.LT.0.D0) THEN
          HFANGL=-DBLE(PARU(1))-HFANGL
        ENDIF
      ENDIF

      RETURN
      END

C***********************************************************************

      SUBROUTINE HFDBRB(IMI,IMA,DTHE,DPHI,DBEX,DBEY,DBEZ)

C--      modification of JETSET73 subroutine to double precision

C...Purpose: to perform rotations and boosts.
      IMPLICIT DOUBLE PRECISION(D)
      COMMON/LUJETS/N,K(4000,5),SP(4000,5),V(4000,5)
      COMMON/HFJETS/DP(4000,5)
      COMMON/LUDAT1/MSTU(200),PARU(200),MSTJ(200),PARJ(200)
      SAVE /LUJETS/,/LUDAT1/,/HFJETS/
      DIMENSION DROT(3,3),DPR(3),DDP(4)

C...Entry for specific range and double precision boost.
      IMIN=IMI
      IF(IMIN.LE.0) IMIN=1
      IMAX=IMA
      IF(IMAX.LE.0) IMAX=N
      DBX=DBEX
      DBY=DBEY
      DBZ=DBEZ

C...Check range of rotation/boost.
  110 IF(IMIN.GT.MSTU(4).OR.IMAX.GT.MSTU(4)) THEN
        CALL LUERRM(11,'(HFDBRB:) range outside LUJETS memory')
        RETURN
      ENDIF

C...Rotate, typically from z axis to direction (theta,phi).
      IF(DTHE**2+DPHI**2.GT.1D-20) THEN
        DROT(1,1)=COS(DTHE)*COS(DPHI)
        DROT(1,2)=-SIN(DPHI)
        DROT(1,3)=SIN(DTHE)*COS(DPHI)
        DROT(2,1)=COS(DTHE)*SIN(DPHI)
        DROT(2,2)=COS(DPHI)
        DROT(2,3)=SIN(DTHE)*SIN(DPHI)
        DROT(3,1)=-SIN(DTHE)
        DROT(3,2)=0.D0
        DROT(3,3)=COS(DTHE)
        DO 140 I=IMIN,IMAX
           IF(K(I,1).LE.0) GOTO 140
           DO 120 J=1,3
              DPR(J)=DP(I,J)
  120      CONTINUE
           DO 130 J=1,3
              DP(I,J)=DROT(J,1)*DPR(1)+DROT(J,2)*DPR(2)+
     +                DROT(J,3)*DPR(3)
  130      CONTINUE
  140   CONTINUE
      ENDIF

C...Boost, typically from rest to momentum/energy=beta.
      IF(DBX**2+DBY**2+DBZ**2.GT.1D-20) THEN
        DB=SQRT(DBX**2+DBY**2+DBZ**2)
        IF(DB.GT.0.99999999D0) THEN
C...Rescale boost vector if too close to unity.
           CALL LUERRM(3,'(HFDBRB:) boost vector too large')
           DBX=DBX*(0.99999999D0/DB)
           DBY=DBY*(0.99999999D0/DB)
           DBZ=DBZ*(0.99999999D0/DB)
           DB=0.99999999D0
        ENDIF
        DGA=1.D0/SQRT(1.D0-DB**2)
        DO 160 I=IMIN,IMAX
           IF(K(I,1).LE.0) GOTO 160
           DO 150 J=1,4
              DDP(J)=DP(I,J)
  150      CONTINUE
           DBP=DBX*DDP(1)+DBY*DDP(2)+DBZ*DDP(3)
           DGABP=DGA*(DGA*DBP/(1D0+DGA)+DDP(4))
           DP(I,1)=DDP(1)+DGABP*DBX
           DP(I,2)=DDP(2)+DGABP*DBY
           DP(I,3)=DDP(3)+DGABP*DBZ
           DP(I,4)=DGA*(DDP(4)+DBP)
  160   CONTINUE
      ENDIF

      RETURN
      END
